# Releases

## Latest Release

v4.17.1 is the latest stable release.

## Development version

Clone the git-cola repository to get the latest development version:

`git clone https://gitlab.com/git-cola/git-cola.git`

## v4.17.1

### Packaging

- `git-cola.appdata.xml` and git-dag.appdata.xml were updated to add vcs-browser links.

### Development

- The "actions/cache" and "actions/upload-artifact" github actions were upgraded.

- Code was updated to avoid using the deprecated codecs.open(...).

- The sphinxtogithub documentation infrastructure no longer uses the optparse module.

### Translations

- Updated Russian translation. (#1545)

## v4.17.0

### Usability, bells and whistles

- Custom "Prepare Commit Message" hooks, typically installed by providing a script at `.git/hooks/cola-prepare-commit-msg`, can now be used on Windows. (#1523) (#1524)

- The File Browser tool will now retain its column widths when files are added, removed or modified. (#1525)

- Bold fonts can now be enabled throughout the entire interface by setting the "Bold all fonts" option in the "Appearance" settings. This setting corresponds to the `cola.boldfonts` git configuration variable. (#1516)

- Git Cola can now read `hunspell` spelling dictionaries. For example, you can install the Spanish hunspell dictionary using `sudo apt install hunspell-es` and then edit the Additional spellcheck dictionary files value in the Preferences to enable the dictionary.

- The amount of time to wait when coalescing filesystem change notifications is now configurable through the Filesystem Monitoring Event Delay value in the Preferences. This setting corresponds to the cola.inotifydelay configuration value. (#1518)

- `ksshaskpass` and the `gnome-ssh-askpass` programs are now detected and used by default when prompting for credentials. Usage of the `GIT_ASKPASS` environment variable was documented. (#1532)

- The commit message is now properly cleared when aborting merges. (#1519)

- The keyboard shortcuts panel now displays macOS hotkeys correctly. (#1512)

- The Git DAG performance was improved when viewing large repositories. (#1526)

- Multiple instances of Git Cola and Git DAG can now be prevented from running in the same repository using the `-S | --single-instance` option. (#1521)

### Translations

- Updated Japanese translation. (#1533)

## v4.16.1

### Fixes

- The "Revert Selected Lines" and "Revert Diff Hunk" actions were sometimes disabled when they should have been enabled. (#1515)

- Backwards-compatibility with PyQt5 and QThread's termination behavior was improved. (#1510)

## v4.16.0

### Usability, bells and whistles

- The stash can now switch modes using `Ctrl + {1,2,3}` and Save stashes using `Ctrl + s`. (#1506)

- git dag now displays the date for `WORKTREE` and `STAGED` entries using the same format as configured in the `cola.logdate` setting. Previously, the `short` and `rfc2822` modes were not implemented. (#1505)

- The scrollbar handles colors have been adjusted to be more visible when using the built-in Dark themes. (#1504)

- Git Cola now has a non-interactive Sync action that directly pulls changes from the configured tracking branch using `git pull`. (#1503)

- Git Cola now has a non-interactive Sync Out action that directly pushes changes to the configured tracking branch using `git push`. (#1508)

### Fixes

- The DAG's filelist widget improved its backwards-compatibility with Qt5. (#1509)

### Packaging

- `pyproject.toml` was updated to use a string value for `project.license`.

## v4.15.0

### Usability, bells and whistles

- Git Cola now supports Git repositories that were created using the SHA-256 hash algorithm, e.g. using `git init --object-format=sha256`.

- git dag will now open a repository when it is specified on the command-line. Previously, the --repo option was required in order to specify a repository. The git dag positional arguments will now used when --repo is unspecified.

- git dag now special-cases the root commit when interacting with difftool so that diffs are performed against git's builtin empty tree. Other commits are diffed using `git diff {commit}~..{commit}`. (#1493)

- The spellcheck system now supports configuring multiple dictionaries using `git config --global --add cola.dictionary <path>` with the path to a newline-separated dictionary file. Dictionary files must follow the same format as `/usr/share/dict/words`.

- Git Cola can now read spelling dictionaries from the aspell system. Configure `git config --global cola.aspell.enabled true` and install `aspell-*` language packages to add additional dictionaries. (#1499)

### Fixes

- Diffing image files (e.g. `*.svg`) in plain text mode has been fixed. (#1498)

## v4.14.0

### Usability, bells and whistles

- Large diffs are now truncated to one megabyte by default for performance. The diff size limit can be changed in the diff editor's options menu. (#1484)

- Renamed files are now detected when diffing commits using the DAG viewer's "Diff selected to this..." and "Diff this to selected..." actions. (#1476)

- The DAG viewer now accepts `-L` arguments just like `git log`.

- The DAG viewer can generate `-L` search expressions using its new "Trace Evolution of Line Range..." context menu action. (#1483)

- A new `git cola open` sub-command can be used to launch the "Quick Open" dialog for opening bookmarked and recently-opened repositories. (#1482)

- code (VSCode) and cursor are now supported for opening files at specific lines. (#1487)

- The Stash tool now ensures that other stashes are displayed when dropping stashes. (#1491)

- The "Merge into current branch" action in the Branches tool now uses `git merge` options as configured in the "Merge" dialog. (#1473)

- The font size for the main UI elements can now be configured in the Preferences. (#1474)

- The commit message editor now displays a visual indicator when amending a commit or when the Author and/or Commit Date has been overridden. (#1490)

- A menu action to revert all changes was added to the diff context menu. (#1492)

### Fixes

- The "Set Upstream Branch" action in the Branches tool was fixed so that it is robust to scenarios where the upstream branch is renamed. (#1475)

- The "Prune Missing Entries" action in the startup dialog and the Bookmarks and Recent tools now save the settings after pruning. (#1479)

- The default history viewer on Windows, used by the "Visualize Current Branch..." and "Visualize All Branches..." actions, was updated to avoid issues when settings are edited. (#1496)

### Translations

- New Tamil translation. (#1478)

### Packaging and Dependencies

- The Windows installer now uses Python 3.12 and PyQt 6.9.

## v4.13.0

### Usability, bells and whistles

- The diff viewer now displays the number of removed (`-`) and added (`+`) lines when the "Show filenames" tool menu option is enabled. (#1471)

- The commit tool has a new "Set Commit Author" tool menu action that temporarily switches between author identities independent of your `git config` settings. The value specified in the dialog is passed directly to `git commit --author=...`. (#1469)

- Widget layouts can now be saved and loaded to `*.layout` files. Layouts are saved to `~/.config/git-cola/layouts` by default and can be saved and loaded using the View > Layouts menu actions. (#1467)

- The status tool has been updated to launch editors with multiple files when invoking its "Edit" action.

- The commit date tool now has a button to set the time and date to the current time.

- The commit message editor now moves up and down visually when word-wrapping is enabled. The cursor previously jumped to the beginning and end of a word-wrapped line when Up and Down were pressed.

### Fixes

- The "Ambiguous shortcut warning" that could be triggered in rare scenarios when using the Amend hotkey has been eliminated.

### Translations

- Updated Japanese translation. (#1472)

## v4.12.0

### Usability, bells and whistles

- Most users will now default to editing the per-repo config by default when opening the settings dialog. New users that do not have the `user.name` and `user.email` settings configured will default to editing the global user settings, which was previously the default behavior for all users. (#1460)

- The rebase tool now honors the rebase.updateRefs git configuration. The tool will only prompt you whether or not to update stacked branches / refs when this configuration is unset. (#1458)

- The rebase.updateRefs configuration can now be configured through the "Update stacked branches/refs when rebasing" checkbox in the settings.

- The branches tool would previously make its branches and tags bold when text was input into its filter field. This behavior has been changed so that the branches and tags are now filtered so that only the matching branches and tags are displayed. (#1457)

- The value of the Force checkbox, which causes `git push --force` to be used in the Push tool, now persists across sessions. (#1461)

- The push dialog will now prompt when creating new remote branches when the local branch name does not match the new remote branch name.

### Fixes

- The push dialog was fixed to use the correct refspec arguments when pushing a local branch into a differently-named remote branch. (#1462)

- The commit message length warning was not being updated in some scenarios. (#1459)

## v4.11.0

### Usability, bells and whistles

- The DAG viewer will now copy text into the your clipboard when any of the commit ID, author, date or summary fields are clicked in the commit diff view. (#1456)

- The DAG viewer now has an option to disable the display of staged and modified changes.

- The commit message line length warning is no longer dependent on the cursor position. The longest line in the commit message is now used to enable the warning. (#1448)

### Fixes

- The DAG view now updates itself when merging branches using the "Branches" tool. (#1454)

- Proxy autodetection on KDE was improved to correctly handle the host and port output from kreadconfig*. (#1450) (#1451) (#1452) (#1453)

- Various widgets were made more resilient to errors when the Git worktree is externally deleted while Git Cola has it open. (#1445)

- Cosmetic typos were fixed in the documentation, translations, docstrings and command-line help messages. (#1446)

## V4.10.1

### Fixes

- A regression in the rebase editor which prevented the display of commits was fixed. (#1442)

- File system monitoring on Windows when using WSL was further improved. (#1441)

### Packaging and Dependencies

- The vendored qtpy library was updated to v2.4.2.

## v4.10.0

### Usability, bells and whistles

- The DAG viewer now displays staged and modified changes alongside other commits. (#1428) (#1439)

- The commit message's Summary field now resizes itself to match the size of the configured font. (#1301) (#1435)

- Git Cola refreshes Git's "index" (`.git/index`) automatically on startup by default. This can now be disabled by configuring `cola.updateindex` to `false`. (#1438)

- The "Set Upstream Branch" menu in the "Branches" tool can grow too large to fit on screen when repositories contain many remote branches. A new dialog with autocomplete and scrollable entry fields was added for selecting a new upstream branch. (#1440)

### Fixes

- Qt6 support was improved for the Recent and Favorites filters.

- A regression in the tab order when tabbing from the Summary field into the Extended Description field has been fixed. (#1436)

- The file system monitoring was made more resilient on Windows when using WSL. (#1441)

## v4.9.0

### Usability, bells and whistles

- `git dag --follow <filename>` is now supported for viewing the history of files that have been renamed. (#1327)

- HTTP proxies are now automatically configured on Gnome and KDE Desktop Environments. (#1420) (#1431)

- The Git `http.proxy` configuration can now be edited on the settings page. (#1420)

- The NO_COLOR environment variable is now set to `1` when running the `git commit`, `git fetch`, `git push` and `git pull` commands. This is done to disable ANSI color output in third-party tools that can be integrated into these commands via git hooks. TERM is also set to dumb for tools that do not honor this variable. (#1426)

- The commit message editor now has a "Set Commit Date" option that allows you to override the recorded date and time when authoring commits. (#1429)

- The DAG's automatic column resizing behavior has been improved. (#1432)

- The "Copy Commit" `Alt + Ctrl + C` action was added to the main menu. (#1430)

- The DAG and main interfaces have been streamlined to reduce visual clutter.

### Translations

- Updated Chinese (Taiwan) translations. (#1424)

### Packaging

- The `setup.cfg` file has been removed and `pyproject.toml` has been updated to handle all of the packaging configuration. `pip` will no longer install data files such as `share/applications`, `share/metainfo`, and the hotkey html files, so the `garden.yaml` and `Makefile` commands have been updated to provide this functionality instead. The html files installed in the `cola/data/` python package area are necessary for Git Cola's `?` hotkey window and should not be relocated.

- notify2 <https://pypi.org/project/notify2> (`sudo apt install python3-notify2`) is now supported and preferred over `notify-py` for sending desktop notifications. This is an optional dependency that enables additional features when installed. `notify-py` will continue to be used if only it is installed, but only notify2 will be used when both are available. Support for the current `notifypy` API will be kept around for now but if a breaking change is ever introduced then support for `notify-py` will be dropped in favor of supporting `notify2` exclusively.

- Improved support for PySide6. PySide2 has some breaking divergences from PyQt6.

### Fixes

- The repository selection startup dialog was updated to work on Qt6/PyQt6. (#1422)

- "Open Using Default Application" now handles paths inside a subdirectory correctly. (#1419)

### Development

- The version number reported by `git cola version` and the "About" dialog was made more accurate when Git Cola is run directly from a Git worktree. (#1425)

## v4.8.2

### Usability, bells and whistles

- The Reset actions now remember the last value used. (#1406)

### Translations

- Updated Japanese translation. (#1411)

### Fixes

- The `Ctrl+C` "Copy Diff" hotkey was restored in the DAG diff viewer. (#1412)

## v4.8.1

### Usability, bells and whistles

- The clone dialog now defaults to cloning into the parent directory by default. (#1402)

### Fixes

- Qt6 support was improved for the right-click context menus. (#1409) (#1410)

## v4.8.0

### Usability, bells and whistles

- The Rebase editor is now aware of the `drop`, `break`, `label`, `merge` and `reset` commands that were added in recent versions of Git.

- Desktop notifications can now be enabled when pushing remotes by enabling the "Notify on Push" option in the preferences. (#1404) (#350)

- Faster and easier commit hash copying in DAG. Left-clicking on the Commit ID will now copy it directly into the clipboard without any further action. (#1401)

- "Grab File from Parent Commit" actions have been added to the DAG. (#1401)

- The Unstage Selected action was added to the context menu for unmerged files. (#1397)

- `git cola rebase` now provides a `--rebase-merges` option and passes the same option to `git rebase` when Git v1.18.0 or newer is detected.

### Development

- Pre-commits hooks were updated. (#1396)

## v4.7.1

### Packaging

- The importlib_metadata dependency which was restored for Python 3.8 and earlier to retain Python 3.7 support. The use of setuptools_scm 8.0 and newer to generate the cola/_scm_version.py version file has been deferred to prevent the need to upgrade Python.

## v4.7.0

### Usability, bells and whistles

- The Fetch dialog can now fetch directly into a remote tracking branch. Previously, fetching just a remote branch would fetch it into FETCH_HEAD, which is not very intuitive. If only a remote branch is selected then it makes more sense to fetch into that branch's remote tracking branch directly. Use FETCH_HEAD in the local branch field to fetch into FETCH_HEAD instead. (#1387)

- The Fetch, Push and Pull dialogs now remember the selected remotes. (#729)

- The Fetch, Push and Pull dialogs now display the git commands that will be run. The Pull dialog now selects the remote branch automatically. (#729)

- The cola.refreshonfocus and cola.inotify configuration settings are now accessible from the git cola config settings dialog.

### Fixes

- The "Ignore" action in the Status context menu now supports adding to the local .git/info/exclude when using linked repositories created using git worktree. (#1394)

- The Cmd-m hotkey on macOS will now minimize the application. The "Amend" action can now be accessed using Alt-m. (#1390) (#1391)

- The git-cola-sequence-editor Rebase Editor will now be found correctly in more situatios on Windows. (#1385) (#1388)

- Git Cola syncs the OS-level filesystem when windows are closed, which can cause performance issues. The cola.sync configuration variable can be configured to false to avoid this behavior. (#1305)

### Packaging

- The importlib_metadata dependency, which was previously required for Python 3.8 and earlier, has been eliminated.

## v4.6.1

### Packaging

- launchable tags were added to the flatpak app metainfo files.

## v4.6.0

### Usability, bells and whistles

- The Rebase editor (git-cola-sequence-editor) can now add "remarks" to commits. Remarks are simple numbered flags (0-9) that allow you to mark commits. This lets you visually highlight commits to aid you when rebasing and grouping related commits across a large patch series. Remarks can be added to a single commit or to all commits that touch a file. (#1375) (#1380)

- Invalid commit.template configuration is now reported in the Console tool instead of presenting an error traceback dialog via a UsageError exception. (#1384)

### Fixes

- The file system monitor was corrected to catch PermissionError exceptions. (bz #2260155)

### Packaging

- If the polib module (e.g. sudo apt install python3-polib) is installed then it will be used instead of the vendored cola.polib module. This makes it easier for distributions to remove the vendored module from the cola namespace. polib is now listed as an install requirement in pyproject.toml. (bz #2264526)

- The flatpak metainfo now contains the required developer name field. (#1382)

### Development

- The "actions/cache" and "styfle/cancel-workflow-action" github actions were upgraded.

- The test suite now uses `ruff` to validate python code. `pylint` is no longer used. (#1353) (#1383)

## v4.5.0

### Usability, bells and whistles

- "Stage Modified" was added to the available toolbar actions. (#1371)

- "Stage Untracked" no longer stages modified files when the list of untracked files to stage is empty. (#1371)

- Ctrl + Space can now be used to display the autocomplete options in input fields that provide autocompletion.

- The Diff widget now displays the currently selected filename. Uncheck the "Show filenames" option in the Diff widget's tool menu to disable this feature. (#1367)

- The "Fetch", "Push" and "Pull" dialogs now have an embedded progress bar instead of displaying a progress bar in a separate popup window.

- The "Fetch", "Push" and "Pull" dialogs will now stay open after the remote operation completes when the "Close on completion" checkbox is unchecked. These dialogs closed themselves unconditionally before this change.

### Fixes

- PyQt6 compatibility for the "Find in diff" feature.

- PyQt6 compatibility for the `git dag` Gravatar icons.

### Translations

- Updated Polish translation. (#1368)

### Packaging and Dependencies

- The vendored qtpy library was updated to v2.4.1.

- The documentation no longer depends on jaraco.packaging.

### Development

- upload-artifact and setup-python github actions were upgraded.

## v4.4.1

### Usability, bells and whistles

- The remote messages dialog is now displayed for the Pull and Push actions in the Branches widget only. This dialog is disabled by default and enabled in the main Push and Pull dialog settings. (#1363)

- The whole-file staging actions in the Diff widget's right-click menu are now listed after the selection and hunk staging actions. This helps prevent accidental clicks from clobbering the index for the entire file. (#1362)

- The completion popup no longer reappears after an item is selected in the "Checkout Branch" action and similar dialogs. (#1360)

### Fixes

- PyQt6 compatibility was improved.

## v4.4.0

### Usability, bells and whistles

- Git Cola now preserves # commentary in commit messages by default. The commit.cleanup Git configuration variable can be used to customize this behavior. For example, if you want Git Cola to strip comments (the old behavior before v4.4.0) then you can run git config --global commit.cleanup strip or configure the "Commit Message Cleanup" setting in the Preferences window. (#1330)

- git dag now includes completions for git log options in the text input field.

- git dag now provides convenient search filters when right-clicking in the text input field.

- A 1.25 x Hi-DPI magnification option mode is now available in the Appearance settings. (#1313)

- MacOS-specific application themes are now available in the Appearance settings when the pyobjc module is installed. (#905)

- Git Cola now runs git commit in the background and feedback is provided while the commit is running. This prevents the UI from freezing when running pre-commit hooks that can make git commit take a long time to run. (#1320)

- The Diff context menu was reworked to reduce visual clutter and better match the Status context menu. (#1347)

- The standalone git cola tag tool now autocompletes the tag name field. (#706) (#691)

- The "Branches" dock widget now has a "Visualize" right-click menu option. (#1061)

- The "Stash" dialog learned to rename stashes. (#558)

- The "Fetch", "Push" and "Pull" dialogs can now display remote messages from the server. (#951)

### Fixes

- git dag fixed how it was handling refspec arguments. (#1334)

- git dag will now properly refresh itself when remote branches are updated. (#1063)

- The cola.inotify feature no longer runs into issues when accessing WSL2 filesystems from Windows 11+. (#1194)

### Development

- cercis is now being used to enforce Git Cola's python code style. We were previously disabling quote normalization when using black. Use of cercis allows us to enable quote normalization under its default single-quote settings.

- The test suite now works on Windows. (#1331) (#1332)

- Pre-commits hooks and code modernization. (#1333)

- Compatibility with Sphinx 7.2.0 was added to the sphinxtogithub sphinx documentation plugin. (#1336)

## v4.3.2

### Usability, bells and whistles

- The minimum font size can now be set lower, which is helpful for Hi-DPI displays. (#1342)

### Fixes

- Flashing windows during startup on Windows has been fixed. (#1329)

- git dag was not displaying history when refspecs were specified. (#1334)

### Development

- Compatibility with Sphinx 7.2.0 was added to the sphinxtogithub sphinx documentation plugin. (#1336)

## v4.3.1

### Fixes

- The pypi wheel was fixed to include entry_points.txt.

- The "Revert" command was throwing an exception after successfully completing.

## v4.3.0

### Usability, bells and whistles

- git dag now displays commit metadata more similarly to git log. The commit date is now displayed and the subject field is displayed directly above the extended description.

- git dag now supports a cola.logdate configuration for controlling the date format. The configured value is passed to git log --date=<format>. (#1319) (#1312)

- The default patches directory that is used when exporting patches is now configurable using the cola.patchesdirectory configuration variable and the Preferences dialog.

- The Diff Editor can now export the diff selection, or the current diff hunk, to a *.patch file from the Patches context menu action.

- Existing patches can be appended to by choosing a patch file from the Append Patch sub-menu in the Patches context menu action.

- Patches can now be applied by dragging and dropping patches files from a file browser onto the diff editor. The "Apply Patches" dialog is launched with the drag-and-dropped patch files.

- Shell completions for zsh are now provided in the source distribution. See the contrib/_git-cola zsh completion file for more details

### Fixes

- `QApplication::desktop()` is no longer available on PyQt6. Git Cola no longer relies on this method.

### Packaging

- Git Cola can now be installed on Windows using winget. See the `README.md` file for more details. (#1318)

## v4.2.1

### Fixes

- Diffs for repositories with a single commit have been fixed. (#1306)

- The toolbars follow the Qt toolbar style, as they did prior to v4.2.0. (#1307)

- The "Checkout Branch" dialog was fixed to display all completions when first shown. (#1308)

## v4.2.0

### Usability, bells and whistles

- The Diff Editor can now send diffs to your favorite editor before the diffs are applied. The right-click "Edit Diff ..." menu actions and the Ctrl + Shift + S / Ctrl + Shift + U hotkeys send the current diff hunk, or the selected diff, to your editor before they are applied to the worktree / staging area. (#1290) (#794)

- The Diff Editor and DAG viewer can now search within their diffs using Ctrl + F and Ctrl + G hotkeys. (#1116)

- A new Diff Mode can be used to diff and unstage edits relative to any commit. (#816)

- The Commit Message Editor can now spell-check the summary field. Previously only the "Extended Description..." field supported spell checking. (#633) (#1070)

- Repositories in your "Recents" and "Favorites" can now be searched using the new "Search" tool button. Quickly switch between these repositories using the Alt + P hotkey and "Quick Open..." File menu action. (#1282)

- "Favorites", "Recents" and the startup dialog now display a case-insensitively sorted list of repositories. (#1047)

- The startup dialog now has a right-click context menu that allows you to prune stale entries and other actions that were not previously accessible from the startup dialog. (#1199) (#1280)

- The "Copy Leading Paths" action in the Status tool's right-click "Copy" sub-menu can now strip off an arbitrary number of leading paths. (#784)

- The "Cherry-Pick" action now reports errors when "git cherry-pick" fails. A new "Abort Cherry-Pick" action has been added for aborting a failed cherry-pick. (#1062)

- The diff text can now be quickly zoomed using Ctrl + Mouse wheel scroll. This will quickly change the text size within the current session only. (#1029)

- The Console and Diff widgets learned to open URLs. Right-click on a line that contains http URLs and context-menu actions for opening each URL using your default web browser will be displayed. (#1139)

- Drag-and-drop has been improved when dragging filenames from the Status tool. Dragging multiple files requires special handling to improve usability. Some terminals (such as kitty) consume multiple file URLs by separating paths with newlines. This is useful when you'd like to capture raw filenames but is less convenient when dropping filenames onto a command-line. Drag with the Alt-modifier held down to drag-and-drop filenames for command-line use. Using the Alt modifier omits URLs so that the drag-and-drop payload includes only space-delimited, shell-quoted paths. (#719)

- The DAG viewer now displays the diff between the start and end commits when multiple commits are selected. The diffs are displayed in the DAG's diff viewer. (#552)

- The DAG viewer learned to checkout branches and initiate rebases from its right-click menu. (#1113)

- The DAG diff viewer learned to word-wrap the diff text. (#1242)

- The spelling dictionaries are now discovered dynamically at runtime. dict/words and dict/propernames are now discovered via $XDG_DATA_DIRS by the spell checker. This allows a spelling dictionary to be placed in e.g.. ~/.local/share/dict/words to override the default /usr/share/dict/words. (#873)

- The File menu now has a "Patches" sub-menu with a full set of "git am" Patch actions.

- The Diff Editor and various Diff widgets now have a "Copy Diff" action with an Alt + Shift + C hotkey that copies the selected diff text to the clipboard with the +, - and <Space> diff prefix characters removed. (#1288)

- The "Revert" action for reverting commits from the DAG tool now displays error messages when `git revert` fails. (#885)

- The Diff Editor now uses an easier-to-see block cursor by default. Disable cola.blockcursor to continue using original line cursor by running `git config --global cola.blockcursor false`, or by editing the settings in the menu.

- The "Unmerged" header item in the Status tool now displays a summary list of unmerged files.

- The hotkeys documentation has been updated to clarify that the "Copy Commit ID" action is available in several tools. (#779)

- Saving files when using "Browse Other Branch" now displays errors from `git show` when saving files from arbitrary commits. (#1065)

- The Apply Patches dialog now reports errors when patches fail to apply. (#673)

- The "Status" tool now disables "Copy" actions in its context menu when no files have been selected. (#697)

- The "Unstage" menu item in the Status tool now uses a "Remove" icon. (#1289)

### Development

- The vendored qtpy module was modified to sever its dependency on the packaging.version module. This mostly affects users that want to run Git Cola directly from the source tree outside of any virtualenv. (#1286)

## v4.1.0

### Usability, bells and whistles

- The rebase editor was taught to handle stacked branch workflows enabled by `git rebase --update-refs`. The `git cola rebase` sub-command now has an `--update-refs` option and the menu actions display a prompt that allows you to enable the updating of stacked branches. (#1261) (#571)

- The status widget now respects diff.ignoreSubmodules. (#1269)

### Packaging and Dependencies

- PyQt6 is now officially supported. (#1211) (#1273)

- The vendored qtpy library was updated to v2.3.0.

### Development

- Fixes and updates to Git Cola's CI actions. (#1278) (#1277)

## v4.0.4

### Fixes

- The "T" hotkey for "Find Files" was removed to avoid issues in some configurations. (#1270)

- Some context menus entries were corrected to better handle binary files. (#1271)

## v4.0.3

### Usability, bells and whistles

- The branches widget no longer loses its selection state in response to notifications and UI actions. (#1221)

- The use of `gravatar.com` to fetch icons associated with author emails can now be disabled by setting git config --global cola.gravatar false. (#933)

### Fixes

- The config reader has been revamped to better read settings when git config files are located in unexpected locations. (#927) (#1264)

- The preferences dialog no longer throws an error when the editor has not been configured. (#1263)

- Context menu actions for staging files has been added when diffing images. (#1265)

- The stash editor now properly displays stashes with slashes ("/") in their names or messages. (#1267)

- The settings file is now written-to and read-from in a robust manner to avoid data loss when doing an ACPI shutdown or forced shutdown of a machine. (#1241)

- Git Cola now displays an error message when attempting to open a repository that cannot be accessed due to the new safe.directory protections in Git v2.30.3. (#1243)

### Translations

- The .po and .pot files now contain location information. (#880)

## v4.0.2

### Usability, bells and whistles

- The Rebase editor (git-cola-sequence-editor) now supports multi-select. Use Shift-{Up,Down} to select multiple lines and the keyboard hotkeys listed in the ? dialog to drive the UI. (#1257)

- The $GIT_VISUAL and $VISUAL environment variable are now consulted in addition to $GIT_EDITOR and $EDITOR when the gui.editor configuration is unset. (#1237)

- The application window icon is now enabled when running on Wayland. (#1240)

- The Status widget now has an "Open Worktree" action. (#1245)

- The "Open Using Default Application", "Open Directory", "Open Parent Directory" and "Open Worktree" actions are now available on Windows.

- The dialog for opening repositories is now a read-only dialog that omits the ability to create folders and modify the filesystem. (#1168)

- A few more git calls have been eliminated from the startup sequence. This further improved the startup time for Git Cola. (#1259)

### Fixes

- Documentation rendering errors have been fixed. (#1256)

- Use of a ~/.config/git-cola/language file to override the language has been fixed. (#1246)

- We no longer write the cola.spellcheck configuration value on launch. (#1238)

### Translations

- Updated Spanish translation. (#1244)

- Updated Japanese translation. (#1249)

### Packaging

- Building documentation offline is supported again. (#1250)

- The Appstream Metadata files were missing in the v4.0.0 release are included again. (#1254) (#1253)

## v4.0.1

### Usability, bells and whistles

- Double-clicking dock widgets no longer creates sub-windows when the layout is locked. (#1176) (#1198)

### Fixes

- We now guard against locale.getdefaultlocale() returning None in some configurations, notably on macOS if none of 'LC_ALL', 'LC_CTYPE', 'LANG' or 'LANGUAGE' are defined. (#1234)

- The preferences dialog has been fixed to properly handle booleans. (#1235)

- The docs/ directory was restructured to avoid missing setup.py errors. share/doc/git-cola is now a symlink pointing to docs/. (#1230)

- Message boxes could sometimes display off-screen or using geometry that is larger than the current desktop. Message box sizes are now clamped to the desktop size. (#1228)

## v4.0.0

### Breaking Changes

These changes are primarily breaking changes for packagers of Git Cola. For example, Linux distribution and Homebrew package maintainers may need to be aware of these changes.

Changes have been made build infrastructure and the resulting filesystem artifacts.

- The build system is now Python3-only and has been modernized for PEP-517/518. While Git Cola still builds and runs under Python2, it is no longer officially supported and may stop working in a future release without notice. (#1201)

- `Qt4` / `PyQt4` is no longer supported.

- The #!/usr/bin/env python shebang lines in the git-cola and git-dag wrapper scripts have been updated to use python3. (#1204)

- The build system was switched to setuptools and no longer depends on distutils. `python setup.py {build,install,build_pot,build_mo}` are no longer provided. Use the https://pypa-build.readthedocs.io/en/stable/installation.html `python -m build` tool to generate sdist and wheel distributions, and `pip install .` to install Git Cola from source. (#1204)

- The git-cola, git-dag and git-cola-sequence-editor commands are now installed using setuptools entry points.

- The bin/ wrapper scripts in the source tree continue to be provided for convenience but they are not the scripts that get installed.

- The qtpy Python package is no longer installed alongside the cola Python package.

- The cola package is now installed into the standard Python site-packages location.

- The share/git-cola/lib private Python modules directory no longer exists.

- The NO_VENDOR_LIBS and NO_PRIVATE_LIBS Makefile options are no longer necessary.

- The share/git-cola filesystem namespace no longer exists. All of cola's package data is distributed alongside the cola module as package data.

- Building the Sphinx documentation now also requires the jaraco.packaging and rst.linker packages. See setup.cfg for the package requirement details.

### Usability, bells and whistles

- Custom UI themes can be used by adding *.qss Qt stylesheet files to ~/.config/git-cola/themes/. (#1222) (#1226)

- Git Cola now keeps track of child Browser windows and will close all of them when the main window is closed. (#1200)

### Fixes

- Staging conflicted binary files has been fixed to avoid Unicode decoding errors. (#1189)

- Ensure that secure permissions are used when creating temporary files. (#1209)

- The line numbering in the diff viewer was corrected when displaying merge diffs. (#1208)

- Documentation typo fixes. (#1193)

- Git Cola was revamped to use Qt signals and slots for all of its notifications. This made its notification system more robust. (#1202) (#1203) (#1205) (#1206)

### Packaging

- vcruntime140.dll and msvcp140.dll are now included in the Windows installation. (#1207)

## v3.12.0

### Usability, bells and whistles

- The git config guitool action can now be grouped under user-defined menus. This is done by using slash (`/`) delimiters in the action name. Entries before the final slash are treated like sub-menus inside the top-level `Actions` menu. (#1150)

- Toolbars now have a full set of icons. The icons follow the system theme and can be configured to display text, just icons, or text and icons. (#1177)

- The startup dialog will now open the selected repository when the "enter" key is pressed. (#1162)

- `Shift+S` will stage selected lines (in addition to `s`). (#1187)

### Fixes

- The vendored qtpy library was patched to retain Python2 compatibility.

- The "Unstage" toolbar action was fixed. (#1178)

- We now avoid QWidget::setWidth(float) for compatibility with newer Qt versions. (#1183)

- Documentation typo fixes. (#1185)

### Translations

- Updated Polish translation. (#1184)

### Development

- Git Cola now uses Github Actions for running its continuous integration tests. (#1179)

## v3.11.0

### Usability, bells and whistles

- The Status tool was improved to better retain selected files when the state changes and the display is refreshed. (#1130) (#1131)

- The Diff editor can now stage selected lines for untracked files. Git Cola will detect when a file is untracked and will allow you to partially stage it, just like existing tracked files. (#1146) (#1084)

- Diffing of staged files has been implemented for repositories that contain no commits. (#1149) (#1110)

- Documentation improvements and typo fixes. (#1163) (#1164)

### Security

- The FIPS security mode is now supported by Git Cola when running on FIPS-enabled Python (Python 3.9+ or centos8/rhel8's patched Python 3.6). (#1157)

### Fixes

- The argparse usage was adjusted to remain compatible with older Pythons. (#1155)

- The window restoration logic was fixed to properly save/restore settings when different languages are used. (#1071) (#1161) (#382)

- git dag no longer passes floats to QPen::setWidth() for better compatibility. (bz #2014950)

### Packaging

- The Windows installer was slimmed down by removing unused Qt DLLs. (#1152)

## v3.10.1

### Fixes

- Patch release to fix a typo in the Interactive Rebase feature.

## v3.10

### Usability, bells and whistles

- The git config reader now supports the include.path directive for including config files. (#1136) (#1137)

- The dialog for selecting commits now support filtering. (#1121)

- The diff editor now wraps long lines by default. The diff options menu can be used to enable/disable line wrapping. (#1123)

- Git Cola now honors core.hooksPath for configuring custom Git hooks, which was introduced in Git v2.9. (#1118)

- A new Ctrl + Shift + S hotkey was added for staging/unstaging all files, both modified and untracked.

- The Status tool now supports Ctrl + A for selecting all files and it behaves more predictably when performing operations when multiple categories of files are selected (e.g. when both modified and untracked header items are selected). (#1117)

### Translations

- Updated Hungarian translation. (#1135)

### Fixes

- The "Interactive Rebase" feature was updated to work with Windows.

- make install-man was updated to support Sphinx 4.0. (#1141)

- git cola --help-commands was updated for newer versions of argparse. (#1133)

### Development

- Git Cola can now be started as a Python module. (#1119)

## v3.9

### Usability, bells and whistles

- The startup dialog now detects when Recent and Favorite repositories no longer exist on disk, and offers to remove these entries when selected. (#1089)

- The startup dialog now includes a simpler and more condensed folder view that can be used for selecting Favorites and Recent repositories. (#1086)

- The "Commit" menu now includes an "Undo Last Commit" action. (#890)

- The "Reset" menu was revamped to expose all of Git's reset modes alongside a new "Restore Worktree" action that updates the worktree using "git read-tree". (#890)

### Translations

- Updated Polish translation. (#1107)

- Updated Japanese translation. (#1098)

- Updated Brazilian translation. (#1091)

### Packaging

- The `--use-env-python` option for `setup.py` is now Python3 compatible. (#1102)

## v3.8

### Usability, bells and whistles

- The submodules widget can now be used to add submodules. Submodules are now updated recursively. (#534)

- The image diff viewer can now be toggled between text and image modes. This is helpful when, for example, diffing .svg files where it can be useful to see diffs in both an image and text representation. (#859) (#1035)

- The default ssh-askpass username + password dialog included with Git Cola can now toggle between showing and masking the password input field. (#1069)

### Translations

- Updated Polish translation. (#1076)

- Updated Hungarian translation. (#1067)

### Packaging

- The share/appdata AppStream data was renamed to share/metainfo in accordance with AppStream standard changes from 2016. (#1079)

- The `cola` modules are now installed into the Python `site-packages` directory by default. This allows distributions to package `git-cola` for multiple versions of Python. See the PACKAGING NOTES section in the README for details about suppressing the installation of the private `share/git-cola/lib/cola` modules when building cola. (#181)

- Git Cola's rebase / sequence editor, formerly known as `git-xbase` and installed as `share/git-cola/bin/git-xbase`, has been renamed to `git-cola-sequence-editor` and is now installed into the default `bin/git-cola-sequence-editor` executable location to enable external reuse of this general-purpose tool.

- A workaround used by the pynsist installer preamble script was obsoleted by takluyver/pynsist#149 and has now been removed. (#1073)

### Fixes

- git dag now uses integer widths when initializing its brushes. (#1080)

## v3.7

### Usability, bells and whistles

- The `git-xbase` rebase editor now includes a file list for filtering the changes displayed in the diff view. (#1051)

- The fallback ssh-askpass script, which provides the Username/Password login dialog when performing remote operations, previously presented both the username and password input fields with `***` asterisks. The dialog now uses asterisks for the password field only. (#1026)

- Stashes can now be applied using the Ctrl + Enter hotkey, popped with the Ctrl + Backspace hotkey, and dropped with the Ctrl + Shift + Backspace hotkey when inside the stash dialog. This enables a keyboard-centric mouse-free workflow when using the stash dialog.

- When amending a commit, git cola will check whether the commit has been published to a remote branch using `git branch -r --contains HEAD`. This command can be slow when operating on a repository with many remote branches. The new cola.checkpublishedcommits configuration variable allows you to opt-out of this check, which improves performance when amending a commit. The settings widget exposes this variable as, "Check Published Commits when Amending". (#1021) (#1027)

### Translations

- Updated Polish translation. (#1033)

### Fixes

- `git-dag.appdata.xml` was updated to allow network access for author icons. (#1050)

- The inotify filesystem monitor now handles OSError: [Errno 24] Too many open files errors by disabling inotify. (#1015)

- Typos in various documentation files have been fixed. (#1025)

- The "Recent Repositories" limit was off by one, and now correctly remembers the configured number of repositories in the menu. (#1024)

- The "revert" action in the DAG and other tools now uses `git revert --no-edit`, which avoids launching an editor when reverting the commit. Use Ctrl+m in the commit message editor after reverting a commit to rewrite its commit message. (#1020)

## v3.6

### Usability, bells and whistles

- The remote editor is much faster since it no longer queries remotes, and uses the cached information instead. (#986)

- Commit message templates can now be loaded automatically by setting `git config cola.autoloadcommittemplate true`. (#1013) (#735)

- The UI layout can now be reset back to its initial state by selecting the "Reset Layout" action. This reverts the layout to the same state as when the app first launched. (#1008) (#994)

- Files can now be ignored in either the project's .gitignore, or in the repository's private local .git/info/exclude ignore file. (#1006) (#1000)

- New remotes are now selected when they are added in the "Edit Remotes" tool. (#1002)

- The "Recent" repositories list is now saved to disk when opening a repository. Previously, this list was only updated when exiting the app. (#1001)

- The bookmarks tool now has a "Delete" option in its right-click menu. (#999)

- The current repository is no longer listed in the "File/Open Recent" menu. (#998)

### Translations

- Updated Hungarian translation. (#1005) (#1018)

- Updated Turkish translation. (#1003) (#1011)

### Fixes

- Better support for Python 3.8's line buffering modes. (#1014)

- The default ssh-askpass script now uses a more generic #! shebang line. (#1012)

- Fetch, push, and pull operations will now refresh the model and display when operations complete. (#996)

- The branches widget now refreshes its display when changing branches. (#992)

### Packaging

- The share/git-cola/bin/git-xbase script will now have its #! lines updated during installation. (#991)

### Development

- The unit tests were made more platform-independent. (#993)

## v3.5

### Usability, bells and whistles

- Auto-completion for filenames can now be disabled. This speeds up revision completion when working in large repositories with many files. (#981)

- The Stash dialog now shows the stash date as a tooltip when hovering over a stashed change. (#982)

- Qt HiDPI settings are overridden by the git cola HiDPI appearance settings. These overrides can now be disabled by selecting the "Disable" mode. This allows users to control the Qt HiDPI settings through environment variables. Additionally, the "Auto" mode now detects the presence of the Qt HiDPI variables and no longer overrides them when the user has configured their environment explicitly. (#963)

- Confirmation dialogs can now focus buttons using the Tab key. Previously, the "Y" and "N" keys could be used to confirm or deny using the keyboard, but "Tab" is more familiar. (#965)

- Error dialogs (for example, when a commit hook fails) will now always show the details. The details were previously hidden behind a toggle. (#968)

### Translations

- Updated Japanese translation. (#973) (#974)

- Updated Simplified Chinese translation. (#950)

### Fixes

- The filesystem monitor no longer logs that it has been enabled after the inotify watch limit is reached on Linux. (#984)

- Better Unicode robustness. (#990) (#910)

- The "Branches" widget did not always update itself when deleting branches (for example, when inotify is disabled or unavailable). (#978)

- Non-ASCII Unicode byte strings are more robustly handled by the log widget. (#977)

- Non-Unicode results from the gettext library are more robustly handled. (#969)

- Launching git cola from within a directory that has since been deleted would previously result in an error, and is now robustly handled. (#961)

### Packaging

- The vendored qtpy library was updated to v1.9.

## v3.4

### Usability, bells and whistles

- The file browser now includes "Blame" in its context menu. (#953)

- The "Push" action now uses "git push --force-with-lease" when using the "Force" option with Git v1.8.5 and newer. (#946)

- Updated German translation. (#936)

- The Status widget learned to optionally display file counts in its category headers, and indent the files displayed in each category. (#931)

- The Branches widget can now sort branches by their most recent commit. (#930)

- git cola now includes configurable GUI themes that can be used to style the user interface. Enable the new themes by configuring cola.theme in the preferences window. See the cola.theme documentation for more details. (#924)

- git cola now has built-in support for HiDPI displays by enabling the Qt 5.6 QT_AUTO_SCREEN_SCALE_FACTOR feature. (#938)

- git cola now uses HiDPI pixmaps when rendering icons, and the builtin icons have been updated to look sharp when displayed in HiDPI. (#932)

### Fixes

- git cola's "Revert Unstaged Edits" previously checked out from "HEAD^", when in "Amend" mode, and removing staged changes. This behavior has been changed to always checkout from the index, which avoids data loss. (#947)

- git cola has been updated to work with newer versions of gnome-terminal and no longer shell-quotes its arguments when launching gnome-terminal. The cola.terminalshellquote configuration variable can be set to true to get the old behavior, or to handle other terminals that take the command to run as a single string instead of as arguments to execv(). (#935)

- git dag now properly handles arbitrary input on Python3. Previously, an exception would be raised when entering --grep=xxx where xxx is a quoted string with a missing end-quote. (#941)

### Development

- The contribution guidelines for contributors has been updated to mention how to regenerate the *.mo message files. (#934)

## v3.3

### Usability, bells and whistles

- git dag improved how it renders parent commits. (#921)

- The Branches widget now checks out branches when double-clicked. (#920)

- The new Submodules widget makes it easy to interact with submodules. Additionally, submodules can now be updated using the Status widget. (#916)

- Updated Japanese translation. (#914)

- The "Open Terminal" action now launches a Git Bash shell on Windows. (#913)

- New menu actions for updating all submodules. (#911)

- The status widget can now update submodules. (#911)

- The "Apply Patch" git cola am dialog now includes a diff viewer to display the contents of the selected patch.

- The "Alt+D" diffstat hotkey now selects the staged/modified/etc. header in the Status widget, which shows the totality of everything that will be committed. (#771)

- Running "Launch Editor" from the diff editor now opens the editor at the current line. (#898)

- The textwidth and tabwidth configuration values can now be set per-repository, rather than globally only.

- Text entry widgets switched to using a block cursor in v3.2. This has been reverted to the original line cursor for consistency with other applications and user expectations. (#889)

- The "edit at line" feature, used by the "Grep" tool, now supports the Sublime text editor. (#894)

### Fixes

- Launching external programs has been improved on Windows. (#925)

- Improve compatibility when using PySide2. (#912)

- The Diff Editor was not honoring the configured tab width on startup. (#900)

- The "Delete Files" feature was creating an unreadable display when many files were selected. Word-wrap the list of files so that the display stays within a sensible size. (#895)

- Spelling and grammar fixes. (#915) (#891)

### Development

- The logo was run through tidy to give it a consistent style. Some technical issues with the logo were improved. (#877)

- The entire codebase is now checked by flake8, rather than just the module and test directories. This catches things like the pynsist installer scripts. (#884) (#882) (#879)

### Packaging

- The vendored qtpy library was updated to v1.6.

- The Windows installer's wrapper scripts were missing an import. (#878)

## v3.2

### Usability, bells and whistles

- The git cola dag DAG window now supports git revert. (#843)

- git stash pop is now supported by the stash dialog. (#844)

- The status widget now ensures that each item is visible when selection changes. Previously, if you scrolled to the right to see the name of a long filename, and then selected a short filename above it, the widget may not have shown the short filename in the viewport. We now ensure that the filenames are visible when the selection changes. (#828)

- The git xbase rebase editor no longer displays an error when cancelling an interactive rebase. (#814)

- The dialog shown when renaming remotes has been simplified. (#840) (#838)

- The help dialog in the git-xbase Rebase editor is now scrollable. (#855)

### Translations

- Updated Brazilian translation. (#845)

- Updated Czech translation. (#854) (#853) (#835) (#813)

- Update Spanish translation. (#862) (#867)

### Packaging

- The original #!/usr/bin/env python shebang lines can now be retained by passing USE_ENV_PYTHON=1 to make when installing. (#850)

- The Makefile is now resilient to DESTDIR and prefix containing whitespace. (#858)

- The vendored qtpy library was updated to v1.4.2.

- python3-distutils is needed to build cola on Debian. (#837)

### Fixes

- The "C" key no longer closes the message dialogs, for example the one that is shown when a commit fails its pre-commit hooks. This allows "Ctrl+C" copy to work, rather than closing the dialog. (#734)

- Dock widgets sizes are now properly saved and restored when the main window is maximized. (#848)

- The spellcheck feature was broken under Python3. (#857)

- A regression when saving stashes was fixed. (#847)

- Diffing image files was not updating the available context menus, which prevented the "Stage" action from being present in the menu. (#841)

- git cola now detects when git lfs uninstall has been run. This allows you to re-initialize "Git LFS" in an existing repository where it had been previously uninstalled. (#842)

- Custom color values that did not contain any hexadecimal digits in the a-f range were being converted into integers by the config reader. This then caused the configured colors to be ignored.

  These color values are now interpreted correctly. Additionally, color values can now use an optional HTML-like # prefix.

  Example .gitconfig snippet:

      [cola "color"]
          text = "#0a0303"

  (#836) (#849)

- We now display an error message graphically when Git is not installed. Previously, the message went to stderr only. (#830)

- Changing diff options was causing resulting in an exception. (#833) (#834)

- The DAG window now updates itself when branches and tags are created. (#814)

- The user's $PATH environment variable can now contain UTF-8 encoded paths. Previously, launching external commands could lead to errors. (#807)

- Git Cola development sandboxes can now be stored on UTF-8 encoded filesystem paths. Previously, the interactive rebase feature could be broken when running in that environment. (#825)

- The log window now uses an ISO-8601 time stamp, which avoids localized output in the log window. (#817)

### Development

- The code base has been thoroughly sanitized using pylint, and Travis is now running pylint over the entire project.

- Miscellaneous improvements and code improvements. (#874)

## v3.1

### Usability, bells and whistles

- The "Browser" widget learned to rename files using "git mv". (#239)

- The "Diff" widget learned to diff images. Side-by-side and pixel diff modes allow you to inspect changes to common images formats. (#444) (#803)

- Git LFS and Git Annex are natively supported by the image diff viewer.

- Git Annex operations are now included. git annex init can be performed on repositories, and git annex add can be run on untracked files from the status widget. Install git-annex to activate this feature.

- Git LFS operations are now included. git lfs install can be performed on repositories, and git lfs track can be run on untracked files from the status widget. Install git-lfs to activate this feature.

- The "Stash" tool learned to stash staged changes only. Select the "Stage Index" option and only staged changes will be stashed away. (#413)

- The "Stash" tool learned to use vim-like navigation keyboard shortcuts, shows error messages when things go wrong, and now saves the "Stash Index" and "Keep Index" options across sessions.

- The Edit menu's "Copy" and "Select All" actions now forward to either the diff, status, recent, or favorites widgets, based on which widget has focus.

- The "File" and "Edit" menu can now be activated using Alt + {F,E} hotkeys. (#759)

- It was easy to accidentally trigger the first action in the Status tool's context menu when using a quick right-click to bring up the menu. A short sub-second delay was added to ensure that the top-most action is not triggered unless enough time has passed. This prevents accidental activation of the first item (typically "Stage" or "Unstage") without burdening common use cases. (#755) (#643)

- The "Ctrl+S" hotkey now works for the header items in the Status tool. Selected the "Modified" header item and activating the "Stage" hotkey, for example, will stage all modified files. This works for the "Staged", "Modified", and "Untracked" headers. This is not enabled for the "Unmerged" header by design. (#772)

- The list of "Recent" repositories previously capped the number of repositories shown to 8 repositories. This can be set to a higher value by setting the cola.maxrecent configuration variable. (#752)

- The "Create Branch" dialog now prevents invalid branch names. (#765)

- Updated Turkish translation. (#756)

- Updated Ukrainian translation. (#753)

- Updated German translation. (#802)

- Updated Czech translation (#792) (#806)

- The window title can be configured to not display the absolute path of the repository. (#775)

- The "Edit Remotes" editor learned to edit remote URLS.

- Bare repositories can now be created by selecting the "New Bare Repository..." action from the File menu.

- The "Branches" widget learned to configure upstream branches.

- A new git cola clone sub-command was added for cloning repositories.

### Packaging

- The vendored qtpy library was updated to v1.3.1.

- The macOS installation was made simpler for better compatibility with Homebrew. (#636)

- The Windows installer is now much simpler. Git Cola now bundles Python and PyQt5, so users need only install the "Git for Windows" and "Git Cola" installers to get things working.

### Fixes

- Uninitialized difftool errors will now be displayed graphically. They were previously going to the shell. (#457)

- Translations marked "fuzzy" will no longer be used when translating strings. (#782)

- Deleted unmerged files will now correctly use a deleted icon. (#479)

- The Ctrl+C "Copy" hotkey on the diff viewer has been fixed. (#767)

- The "Create Tag" dialog did not correctly handle the case when a signed tag is requested, but no message is provided, and the user chooses to create a non-annotated tag instead. This convenience fallback will now properly create an unsigned, non-annotated tag. (#696)

- .gitconfig and .git/config values editable by the Preferences dialog (aka git cola config) will now get unset when set to an empty value. For example, setting a different user.email in the current repository, followed by a subsequent emptying of that field, would previously result in an empty string getting stored in the config. This has been fixed so that the value will now get unset in the config instead. (#406)

- Spelling and typo fixes. (#748)

- core.commentChar is now honored when set in the local repository .git/config. (#766)

- The log window was using a format string that did not display correctly in all locales. A locale-aware format is now used. (#800)

- The dialog displayed when prompting for a reference could sometimes lose focus. (#804)

## v3.0

### Usability, bells and whistles

- Updated Simplified Chinese translation. (#726)

- Updated Ukrainian translation. (#723)

- New Czech translation. (#736) (#737) (#740) (#743)

- The "name" field in the "Create Tag" dialog now includes autocompletion, which makes it easy to see which tags currently exist.

- git cola now has configurable toolbars. Use the View > Add toolbar menu item to add a toolbar.

- Setting cola.expandtab to true will now expand tabs into spaces in the commit message editor. The number of spaces to insert is determined by consulting cola.tabwidth, which defaults to 8.

- The "Copy SHA-1" hotkey is now Alt + Ctrl + C, to avoid clobbering the ability to copy text from the DAG window. (#705)

- The "Prepare Commit Message" action can now be invoked via the Ctrl+Shift+Return shortcut. (#707)

- The Branches pane now has a filter field that highlights branches whose names match the string entered into its text field. (#713)

- Actions that are triggered in response to button presses were being triggered when the button was pressed, rather than when it was released, which was a usability flaw. All buttons now respond when clicked rather than when pressed. (#715)

- The DAG window will now only refresh when object IDs change. Previously, the DAG would redraw itself in response to inotify events, such as filesystem operations, which was disruptive when inspecting a large diff in its diff viewer. The DAG will now only redraw when the object IDs corresponding to its query input changes. Furthermore, when redrawing, the scrollbar positions are retained to minimize disruption to the viewport contents. (#620) (#724)

- The "About" dialog now includes the SHA-1 where Git Cola was built. (#530)

- The "Status" widget now has "Copy Leading Path to Clipboard" and "Copy Basename to Clipboard" actions. (#435) (#436)

- The "Status" widget now supports custom "Copy xxx to Clipboard" actions. (#437)

- The main menu now has an "Edit" menu. (#725)

- git dag learned to checkout commits into a detached HEAD state. (#698)

- The status widget's context menus now omit actions selection-dependent actions when no file is selected. (#731)

- The startup dialog now focuses the repository list so that repositories can be selected with the keyboard without mouse intervention. (#741)

### Fixes

- git dag now prevents nodes from overlapping in more situations. (#689)

- Adding untracked Git submodule repo directories previously ran git add submodule/ but we now call git add submodule without the trailing slash (/) to avoid staging files that belong to the submodule (which is possibly a git bug). By working around the buggy behavior we allow users to recover by issuing the appropriate git submodule add command to properly register the submodule. (#681)

- We now avoid git for-each-ref --sort=version:refname on versions of git older than v2.7.0. Previously we only avoided it for versions older than v2.0.0, which was a mistake. (#686)

- The error message displayed when git is not installed has been fixed. (#686)

- Adding new remotes was silently broken. (#684) (#685)

- The repo selection dialog had errors during startup when the cola.refreshonfocus feature was enabled, as reported on Ubuntu 16.04. (#690)

- Restored support for PyQt 4.6 (Centos 6.8) (#692)

- Switching repositories now resets the "Amend Mode" and other settings when switching. (#710)

- git rebase error messages now displayed when rebasing fails or stops via the standalone git cola rebase front-end. (#721)

- git cola learned to stage broken symlinks. (#727)

- The "View History" feature in the Browser tool was fixed, and now disambiguates between refs and paths. (#732)

- The diff editor now has better support for files with CRLF rn line endings. (#730)

- cola.inotify in a repo-local config is now honored when git cola is launched from a desktop entry (git cola --prompt). (#695)

## v2.11

### Usability, bells and whistles

- New Ukrainian translation. (#670) (#672)

- New and improved French translations.

- The new Branches widget makes it easier to checkout, merge, push, and pull branches from a single interface.

- git cola now includes a dark icon theme. The dark icon theme can be activated either by setting the GIT_COLA_ICON_THEME environment variable to dark, by configuring cola.icontheme to dark, or by specifying --icon-theme=dark on the command line. (#638)

- Autocompletion was added to the Fetch, Push, and Pull dialogs.

- The commit message editor now remembers the "Spellcheck" setting after exiting. (#645)

- git dag now uses an improved algorithm for laying out the graph, which avoids collisions under certain graph configurations, and avoids overlapping tag with commits. (#648) (#651) (#654) (#656) (#659)

- git dag now remembers its column sizes across sessions. (#674)

- Grep now shows a preview of the selected file's content in a split window below the grep results.

- Grep now includes line numbers in the preview pane's output.

- Edit Remotes now remembers its window settings after exiting.

- Diff now has an option to display line numbers in the editor. (#136)

- Amend Last Commit can now be triggered via the Commit menu in addition to the commit message editor's options. (#640)

- The File Browser tool was made much faster and can now operate on much larger repositories. (#499)

- A new "turbo" mode was added that allows you to opt-out of operations that can slow git cola on large repositories. The turbo mode is enabled by configuring git config cola.turbo true. Turbo mode disables the background loading of Git commit messages and other details in the File Browser widget.

- A new GitIgnore dialog allows adding custom gitignore patterns. (#653)

- The spellchecker in git cola can now use an additional dictionary by configuring cola.dictionary to the path to a file containing a newline-separated list of words. (#663)

- The stash, export patches, diff, and gitignore dialogs now remember their window sizes.

- A new git cola recent sub-command was added for finding recently edited files.

- The Fetch dialog now allows pruning remote branches. (#639) (#680)

### Fixes

- git cola's spellchecker now supports the new dict-common filesystem layout, and prefers the /usr/share/dict/cracklib-small file over the /usr/share/dict/words provided on older distributions. This makes the spellchecker compatible with Arch, which does not provide a words symlink like Debian. (#663)

- Properly handle the case where an existing file is untracked using the File Browser.

- Fix a quirk where the "Create Branch" dialog sometimes required clicking twice on the radio buttons. (#662)

- Fixed a focus issue to ensure that "Push", "Fetch", and "Pull" can be executed with the press of a single enter key after being shown. (#661)

- Committing is now allowed in when resolving a merge results in no changes. This state was previously prevented by the commit message editor, which prevented users from resolving merges that result in no changes. (#679)

- The filesystem monitor would sometimes emit backtraces when directories are modified. This has been fixed. (bz #1438522)

- Absolute paths are now returned when querying for .git-relative paths from within a submodule, which uses .git-files. This fixes launching git cola from within a subdirectory of a submodule. (#675)

## v2.10

### Usability, bells and whistles

- git cola can now invoke the .git/hooks/cola-prepare-commit-msg hook to update the commit message. This hook takes the same parameters as Git's prepare-commit-message hook. The default path to this hook can be overridden by setting the cola.prepareCommitMessageHook configuration variable. (Documentation)

- git cola diff (and the corresponding Diff menu actions) can now launch difftool with the standard Ctrl+D hotkey. The Ctrl+E hotkey was also added for launching an editor.

### Translations

- Traditional Chinese (Taiwan) translation updates.

### Fixes

- git cola now works when installed in non-ASCII, UTF-8-encoded paths. (#629)

- Styling issues that caused black backgrounds in various widgets when using PyQt5 on Mac OS X have been fixed. (#624)

- The "Open Recent" menu action was broken and has been fixed. (#634)

- Exiting git cola with a maximized main window would hang when reopened on Linux. (#641)

### Packaging

- appdata.xml files are now provided at share/appdata/git-cola.xml and share/appdata/git-dag.xml for use by the Linux software gallery. (#627) (Appdata)

## v2.9.1

### Fixes

- The "Open Recent" menu was updated to new bookmarks format. (#628)

## v2.9

### Usability, bells and whistles

- New Polish translation thanks to Łukasz Wojniłowicz (#598)

- The Bypass Commit Hooks feature now disables itself automatically when a new commit is created. The new behavior turns the option into a single-use flag, which helps prevent users from accidentally leaving it active longer than intended. (#595)

- git dag learned to launch an external diff viewer on selected commits. The standard Ctrl+D shortcut can be used to view diffs. (#468)

- git dag learned to launch directory diffs via git difftool --dir-diff. The Ctrl+Shift+D shortcut launches difftool in directory-diff mode. (#468)

- Items in the "Favorites" list can now be renamed, which makes it easier to differentiate between several checkouts of the same repository. (#599) (#601)

- The startup screen now includes a logo and git cola version information. (#526)

- The About page was revamped to contain multiple tabs. A new tab was added that provides details about git cola''s dependencies. New tabs were also added for giving credit to git cola's authors and translators.

- The About page can now be accessed via git cola about.

- The "Fast-forward only" and "No fast-forward" options supported by git pull are now accessible via git cola pull.

- Doing a forced push no longer requires selecting the remote branch. (#618)

- git cola push now has an option to suppress the prompt that is shown when pushing would create new remote branches. (#605)

- git dag now shows commit messages in a more readable color. (#574)

- git cola browse and the status widget learned to launch the OS-specified default action for a file. When used on directories via git cola browse, or when "Open Parent Directory" is used on files, the OS-specified file browser will typically be used.

- git cola browse and the status widget learned to launch terminals.

### Fixes

- git cola browse was not updating when expanding items. (#588)

- Typo fixes in comments, naming, and strings have been applied. (#593)

- The inotify and win32 filesystem monitoring no longer refreshes when updates are made to ignored files. (#517) (#516)

- The Refresh button on the actions panel no longer raises an exception when using PyQt5. (#604)

- Fixed a typo in the inotify back-end that is triggered when files are removed. (#607)

- Fixed a typo when recovering from a failed attempt to open a repository. (#606)

- git dag now properly updates itself when launched from the menu bar. (#613)

- If git-cola is invoked on Windows using start pythonw git-cola, a console window will briefly flash on the screen each time git cola invokes git. The console window is now suppressed.

- We now avoid some problematic Popen flags on Windows which were breaking the git rebase feature on Windows.

- The Save button in git dag's "Grab File..." feature now properly prompts for a filename when saving files. (#617)

### Development

- The qtpy symlink in the source tree has been removed to allow for easier development on Windows. (#626)

## v2.8

### Usability, bells and whistles

- git cola push learned to configure upstream branches. (#563)

### Fixes

- The diffstat view is now properly updated when notifications are received via inotify filesystem monitoring. (#577)

- Python3 with PyQt5 had a bug that prevented git cola from starting. (#589)

## v2.7

### Fixes

- When repositories stored in non-ASCII, UTF-8-encoded filesystem paths were operated upon with LC_ALL=C set in the environment, Unicode errors would occur when using python2. git cola was made more robust and will now operate correctly within this environment. (#581)

- Support for the GIT_WORK_TREE environment variable was fixed. (#582)

### Development

- The unittest.mock module is now used instead of the original mock module when running the git cola test suite using Python3. (#569)

### Packaging

- git cola is now compatible with PyQt5, PyQt4, and Pyside. git cola previously supported PyQt4 only, but will now use whichever library is available. Users are not required to upgrade at this time, but PyQt5 support can be enabled anytime by making its python modules available. (#232)

  NOTE: We do not yet recommend using PyQt5 because there are known exit-on-segfault bugs in Qt5 that have not yet been addressed. git cola is sensitive to this bug and is known to crash on exit when using git dag or the interactive rebase feature on PyQt5.

  https://bugreports.qt.io/browse/QTBUG-52988

  PyQt4 is stable and there are no known issues when using it so we recommend using it until the Qt5 bugs have been resolved.

- git cola now depends on QtPy and includes a bundled copy of the qtpy library. If you are packaging git cola and would prefer to use qtpy from your distribution instead of the built-in version then use make NO_VENDOR_LIBS=1 when building git cola. This will prevent vendored libraries from being installed.

## v2.6

### Usability, bells and whistles

- A new "Reset" sub-menu provides access to running "git reset --mixed" when resetting branch heads and "git reset --merge" when resetting worktrees. (#542)

- git cola now supports linked worktrees, i.e. worktrees created by git worktree. (#554)

### Fixes

- Diff highlighting is now robust to the user having diff.supressBlankEmpty=true in their git config. (#541)

- The filesystem monitor now properly handles repositories that use .git-files, e.g. when using submodules. (#545) (#546)

- Per-repository git configuration is now properly detected when launching git cola from an application launcher. (#548)

- git cola now cleans up after itself immediately to avoid leaving behind empty /tmp/git-cola-XXXXXX directories when the user uses Ctrl+C to quit the app. (#566)

### Packaging

- It is now possible to install git cola to and from UTF-8-encoded filesystem paths. Previously, Python's stdlib would throw an encoding error during installation. We workaround the stdlib by forcing python2 to use UTF-8, thus fixing assumptions in the stdlib library code. (#551)

## v2.5

### Usability, bells and whistles

- The icon for untracked files was adjusted to better differentiate between files and the "Untracked" header. (#509)

- Ctrl+O was added as a hotkey for opening repositories. (#507)

- git dag now uses consistent edge colors across updates. (#512)

- git cola's Bookmarks widget can now be used to set a "Default Repository". Under the hood, we set the cola.defaultrepo configuration variable. The default repository is used whenever git cola is launched outside of a Git repository. When unset, or when set to a bogus value, git cola will prompt for a repository, as it previously did. (#513)

- git cola's Russian and Spanish translations were improved thanks to Vaiz and Zeioth. (#514) (#515) (#523)

- git cola was translated to Turkish thanks to Barış ÇELİK. (#520)

- The status view now supports launching git gui blame. It can be configured to use a different command by setting cola.blameviewer. (#521)

- git dag now allows selecting non-contiguous ranges in the log widget. (#468)

- Any font can now be chosen for the diff editor, not just mono-space fonts. (#525)

### Fixes

- xfce4-terminal and gnome-terminal are now supported when launching git mergetool to resolve merges. These terminals require that the command to execute is shell-quoted and passed as a single string argument to -e rather than as additional command line arguments. (#524)

- Fixed a Unicode problem when formatting the error message that is shown when gitk is not installed. We now handle Unicode data in tracebacks generated by python itself. (#528)

- The New repository feature was fixed. (#533)

- We now use omit the extended description when creating "fixup!" commits, for consistency with the Git CLI. We now include only the one-line summary in the final commit message. (#522)

## v2.4

### Usability, bells and whistles

- The user interface is now HiDPI-capable. Git Cola now uses SVG icons, and its interface can be scaled by setting the GIT_COLA_SCALE environment variable.

- git dag now supports the standard editor, difftool, and history hotkeys. It is now possible to invoke these actions from file widget's context menu and through the standard hotkeys. (#473)

- The Status tool also learned about the history hotkey. Additionally, the Alt + {J,K} aliases are also supported in the Status tool for consistency with the other tools where the non-Alt hotkeys are not available. (#488)

- The File Browser tool now has better default column sizes, and remembers its window size and placement.

- The File Browser now supports the refresh hotkey, and has better behavior when refreshing. The selection is now retained, and new and removed files are found when refreshing.

- A new git-cola-completion.bash completion script is provided in the contrib/ directory. It must be used alongside Git's completion script. Source it from your ~/.bashrc (or ~/.zshrc, etc) after sourcing the git-completion.bash script and you will have command-line completion support for the git cola and git dag sub-commands.

- The "checkout" dialog now offers completion for remote branches and other git refs. This makes it easier to checkout remote branches in a detached head state. Additionally, the checkout dialog also offers completion for remote branches that have not yet been checked out, which makes it easier to create a local tracking branch by just completing for that potential name. (#390)

- The "create branch" and "create tag" dialogs now save and restore their window settings.

- The "status" widget can now be configured to use a bold font with a darker background for the header items. (#506)

- The "status" widget now remembers its horizontal scrollbar position across updates. This is helpful when working on projects with long paths. (#494)

### Fixes

- When using Git for Windows, a git window would appear when running Windows 8. We now pass additional flags to subprocess.Popen to prevent a git window from appearing. (#477) (#486)

- Launching difftool with .PY in $PATHEXT on Windows was fixed. (#492)

- Creating a local branch tracking a remote branch that contains slashes in its name is now properly handled. (#496)

- The "Browse Other Branch" feature was broken by Python3, and is now fixed. (#501)

- We now avoid long for better Python3 compatibility. (#502)

- We now use Git's default merge message when merging branches. (#508)

- Miscellaneous fixes (#485)

### Packaging

- git-cola's documentation no longer uses an inter-sphinx link mapping to docs.python.org. This fixes warnings when building RPMs using koji, where network access is prevented.

  https://bugzilla.redhat.com/show_bug.cgi?id=1231812

## v2.3

### Usability, bells and whistles

- The Interactive Rebase feature now works on Windows! (#463)

- The diff editor now understands vim-style hjkl navigation hotkeys. (#476)

- Alt + {J,K} navigation hotkeys were added to allow changing to the next/previous file from the diff and commit editors.

- The Rename branch menu action is now disabled in empty repositories. (#475) (#459)

- git cola now checks unmerged files for conflict markers before staging them. This feature can be disabled in the preferences. (#464)

- git dag now remembers which commits were selected when refreshing so that it can restore the selection afterwards. (#480)

- "Launch Editor", "Launch Difftool", "Stage/Unstage", and "Move Up/Down" hotkeys now work when the commit message editor has focus. (#453)

- The diff editor now supports the Ctrl+u hotkey for reverting diff hunks and selected lines.

- The core.commentChar Git configuration value is now honored. Commit messages and rebase instruction sheets will now use the configured character for comments. This allows having commit messages that start with # when core.commentChar is configured to its non-default value. (#446)

### Fixes

- Diff syntax highlighting was improved to handle more edge cases and false positives. (#467)

- Setting commands in the interactive rebase editor was fixed. (#472)

- git-cola no longer clobbers the Ctrl+Backspace text editing shortcut in the commit message editor. (#453)

- The copy/paste clipboard now persists after git cola exits. (#484)

## v2.2.1

### Fixes

- Fixed the "Sign off" feature in the commit message editor.

## v2.2

### Usability, bells and whistles

- Double-click will now choose a commit in the "Select commit" dialog.

- git cola has a feature that reads .git/MERGE_MSG and friends for the commit message when a merge is in-progress. Upon refresh, git cola will now detect when a merge has completed and reset the commit message back to its previous state. It is only reset if the editor contains a message that was read from the file and has not been manually edited by the user.

- The commit message editor's context menu now has a "Clear..." action for clearing the message across both the summary and description fields.

- The system theme's icons are now used wherever possible. (#458)

### Translations

- Traditional Chinese (Taiwan) translation updates.

### Fixes

- The stash viewer now uses `git show --no-ext-diff` to avoid running user-configured diff tools.

- git cola now uses the setsid() system call to ensure that the GIT_ASKPASS and SSH_ASKPASS helper programs are used when pushing changes using git. The askpass helpers will now be used even when git cola is launched from a terminal.

  The behavior without setsid() is that git cola can appear to hang while pushing changes. The hang happens when git prompts the user for a password using the terminal, but the user never sees the prompt. setsid() detaches the terminal, which ensures that the askpass helpers are used. (#218) (#262) (#377)

- git dag's file list tool was updated to properly handle Unicode paths.

- gnome-terminal is no longer used by default when cola.terminal is unset. It is broken, as was detailed in #456. (#456)

- The interactive rebase feature was not always setting $GIT_EDITOR to the value of gui.editor, thus there could be instances where rebase will seem to not stop, or hang, when performing "reword" actions.

  We now set the $GIT_EDITOR environment variable when performing the "Continue", "Skip", and "Edit Todo" rebase actions so that the correct editor is used during the rebase. (#445)

### Packaging

- git cola moved from a 3-part version number to a simpler 2-part "vX.Y" version number. Most of our releases tend to contain new features.

## v2.1.2

### Usability, bells and whistles

- Updated zh_TW translations.

- git cola rebase now defaults to @{upstream}, and generally uses the same CLI syntax as git rebase.

- The commit message editor now allows you to bypass commit hooks by selecting the "Bypass Commit Hooks" option. This is equivalent to passing the --no-verify option to git commit. (#357)

- We now prevent the "Delete Files" action from creating a dialog that does not fit on screen. (#378)

- git xbase learned to edit rebase instruction sheets that contain exec commands.

- The diff colors are now configurable. cola.color.{text,add,remove,header} can now be set with 6-digit hexadecimal colors. See the git cola manual <https://git-cola.readthedocs.io/en/latest/git-cola.html#configuration-variables>_ for more details.

- Improved hotkey documentation.

### Fixes

- git cola will now allow starting an interactive rebase with a dirty worktree when rebase.autostash is set. (#360)

## v2.1.1

### Usability, bells and whistles

- A new "Find files" widget was added, and can be activated by using the Ctrl+t or t hotkeys.

- A new git cola find sub-command was added for finding files.

- git cola now remembers the text cursor's position when staging interactively with the keyboard. This makes it easier to use the keyboard arrows to select and stage lines.

- The completion widgets will now select the top completion item when Enter or Return are pressed.

- You can now refresh using F5 in addition to the existing Ctrl+R hotkey.

### Fixes

- git cola now passes --no-abbrev-commit to git log to override having log.abbrevCommit = true set in .gitconfig.

## v2.1.0

### Usability, bells and whistles

- git dag now forwards all unknown arguments along to git log. (#389)

- Line-by-line interactive staging was made more robust. (#399)

- "Bookmarks" was renamed to "Favorites". (#392)

- Untracked files are now displayed using a unique icon. (#388)

### Fixes

- git dag was triggering a traceback on Fedora when parsing Git logs. (bz #181676)

- inotify expects Unicode paths on Python3. (#393)

- Untracked files are now assumed to be UTF-8 encoded. (#401)

## v2.0.8

### Usability, bells and whistles

- git cola can now create GPG-signed commits and merges. See the documentation for details about setting up a GPG agent. (#149)

- The status widget learned to copy relative paths when Ctrl+x is pressed. (#358)

- Custom GUI actions can now define their own keyboard shortcuts by setting guitool.$name.shortcut to a string understood by the Qt QKeySequence API, e.g. Alt+X. See the Qt docs for more details about the supported values.

- git cola learned to rename branches. (#364) (#278)

- git dag now has a "Show history" context menu which can be used to filter history using the selected paths.

### Fixes

- sphinxtogithub.py was fixed for Python3. (#353)

- The commit that changed how we read remotes from git remote to parsing git config was reverted since it created problems for some users.

- Fixed a crash when using the rebase edit feature. (#351)

- Better drag-and-drop behavior when dropping into gnome-terminal. (#373)

### Packaging

- The git-cola-folder-handler.desktop file handler was fixed to pass validation by desktop-file-validate. (#356)

- The git.svg icon was renamed to git-cola.svg, and git cola was taught to prefer icons from the desktop theme when available.

## v2.0.7

### Usability, bells and whistles

- New hotkey: Ctrl+Shift+M merges branches.

- New hotkey: Ctrl+R refreshes the DAG viewer. (#347)

### Fixes

- We now use git config to parse the list of remotes instead of parsing the output of git remote, which is a Git porcelain and should not be used by scripts.

- Avoid "C++ object has been deleted" errors from PyQt4. (#346)

### Packaging

- The make install target now uses install instead of cp.

## v2.0.6

### Usability, bells and whistles

- Updated Brazilian Portuguese translation.

- The status and browse widgets now allow drag-and-drop into external applications. (#335)

- We now show a progress bar when cloning repositories. (#312)

- The bookmarks widget was simplified to not need a separate dialog. (#289)

- Updated Traditional Chinese translation.

- We now display a warning when trying to rebase with uncommitted changes. (#338)

- The status widget learned to filter paths. Ctrl+Shift+S toggles the filter widget. (#337) (#339)

- The status widget learned to move files to the trash when the send2trash module is installed. (#341)

- "Recent repositories" is now a dedicated widget. (#342)

- New Spanish translation thanks to Pilar Molina Lopez. (#344)

### Fixes

- Newly added remotes are now properly seen by the fetch/push/pull dialogs. (#343)

## v2.0.5

### Usability, bells and whistles

- New Brazilian Portuguese translation thanks to Vitor Lobo.

- New Indonesian translation thanks to Samsul Ma'arif.

- Updated Simplified Chinese translation thanks to Zhang Han.

- Ctrl+Backspace is now a hotkey for "delete untracked files" in the status widget.

- Fetch/Push/Pull dialogs now use the configured remote of the current branch by default. (#324)

### Fixes

- We now use os.getcwd() on Python3. (#316) (#326)

- The Ctrl+P hotkey was overloaded to both "push" and "cherry-pick", so "cherry-pick" was moved to Ctrl+Shift+C.

- Custom GUI tools with mixed-case names are now properly supported.

- "Diff Region" is now referred to as "Diff Hunk" for consistency with common terminology from diff/patch tools. (#328)

- git-cola's test suite is now portable to MS Windows. (#332)

## v2.0.4

### Usability, bells and whistles

- We now handle the case when inotify add_watch() fails and display instructions on how to increase the number of watches. (#263)

- New and improved zh_TW localization thanks to Ｖ字龍(Vdragon). (#265) (#267) (#268) (#269) (#270) (#271) (#272)

- New hotkeys: Ctrl+F for fetch, Ctrl+P for push, and Ctrl+Shift+P for pull.

- The bookmarks widget's context menu actions were made clearer. (#281)

- The term "Staging Area" is used consistently in the UI to allow for better localization. (#283)

- The "Section" term is now referred to as "Diff Region" in the UI. (#297)

- The localization documentation related to the LANGUAGE environment variable was improved. (#293)

- The "Actions" panel now contains tooltips for each button in case the button labels gets truncated by Qt. (#292)

- Custom git config-defined actions can now be run in the background by setting guitool.<name>.background to true.

### Fixes

- We now use bold fonts instead of SmallCaps to avoid artifacts on several configurations.

- We now pickup user.email, cola.tabwidth, and similar settings when defined in /etc/gitconfig. (#259)

- Better support for Unicode paths when using inotify. (bz #1104181)

- Unicode fixes for non-ASCII locales. (#266) (#273) (#276) (#282) (#298) (#302) (#303) (#305)

- Viewing history from the file browser was fixed for Python3. (#274)

- setup.py was fixed to install the *.rst documentation. (#279)

- Patch export was fixed for Python3. (#290)

- Fixed adding a bookmark with trailing slashes. (#295)

- The default git dag layout is now setup so that its widgets can be freely resized on Linux. (#299)

- Invalid tag names are now reported when creating tags. (#296)

## v2.0.3

### Usability, bells and whistles

- git cola no longer prompts after successfully creating a new branch. (#251)

- Hitting enter on simple dialogs now accepts them. (#255)

### Fixes

- git dag no longer relies on sys.maxint, which is not available in Python3. (#249)

- Python3-related fixes. (#254)

- Python3-on-Windows-related fixes. (#250) (#252) (#253)

- Switching repositories using the bookmarks widget was not refreshing the inotify watcher. (#256)

- Special commit messages trailers (e.g. "Acked-by:") are now special-cased to fix word wrapping lines that start with "foo:". (#257)

- git dag sometimes left behind selection artifacts. We now refresh the view to avoid them. (#204)

## v2.0.2

### Usability, bells and whistles

- Better inotify support for file creation and deletion. (#240)

- git cola now supports the X11 Session Management Protocol and remembers its state across logout/reboot. (#164)

- git cola has a new icon. (#190)

### Packaging

- Building the documentation no longer requires asciidoc. We now use Sphinx for building html documentation and man pages.

### Fixes

- Reworked the git-dag gravatar icon code to avoid a Unicode error in Python 2.

- Commit message line-wrapping was made to better match the GUI editor. (#242)

- Better support for Python3 on Windows (#246)

### Packaging

- git-cola no longer depends on Asciidoc for building its documentation and man-pages. We now depend on [Sphinx](https://www.sphinx-doc.org) only.

## v2.0.1

### Usability, bells and whistles

- Some context menu actions are now hidden when selected files do not exist. (#238)

### Fixes

- The build-git-cola.sh contrib script was improved. (#235)

- Non-ASCII worktrees work properly again. (#234)

- The browser now guards itself against missing files. (bz #1041378)

- Saving widget state now works under Python3. (#236)

## v2.0.0

### Portability

- git-cola now runs on Python 3 thanks to Virgil Dupras. (#233)

- Python 2.6, 2.7, and 3.2+ are now supported. Python 2.5 is no longer supported.

### Fixes

- i18n test fixes thanks to Virgil Dupras. (#231)

- git-cola.app build fixes thanks to Maicon D. Filippsen. (#230)

- Lots of pylint improvements thanks to Alex Chernetz. (#229)

## v1.9.4

### Usability, bells and whistles

- The new Bookmarks tool makes it really easy to switch between repositories.

- There is now a dedicated dialog for applying patches. See the `File > Apply Patches` menu item. (#215)

- A new git cola am sub-command was added for applying patches.

### Fixes

- Fixed a typo that caused inotify events to be silently ignored.

- Fixed the sys.path setup for Mac OS X (Homebrew). (#221)

- Lots of pylint fixes thanks to Alex Chernetz.

## v1.9.3

### Usability, bells and whistles

- git cola --amend now starts the editor in amend mode. (#187)

- Multiple lines of text can now be pasted into the summary field. All text beyond the first newline will be automatically moved to the extended description field. (#212)

### Fixes

- Stray whitespace in .git files is now ignored. (#213)

- Fix "known incorrect sRGB profile" in staged-item.png. (gentoo-devel message #85066)

## v1.9.2

### Fixes

- Fix a traceback when git push fails. (bz #1034778)

### Packaging

- Most of the git-cola sub-packages have been removed. The only remaining packages are cola, cola.models, and cola.widgets.

- The translation file for Simplified Chinese was renamed to zh_CN.po. (#209)

## v1.9.1

### Packaging

- git cola version --brief now prints the brief version number.

### Fixes

- Resurrected the "make dist" target, for those that prefer to create their own tarballs.

- Fixed the typo that broke the preferences dialog.

## v1.9.0

### Usability, bells and whistles

- We now ship a full-featured interactive git rebase editor. The rebase todo file is edited using the git xbase script which is provided at $prefix/share/git-cola/bin/git-xbase. This script can be used standalone by setting the $GIT_SEQUENCE_EDITOR before running git rebase --interactive. (#1)

- Fixup commit messages can now be loaded from the commit message editor.

- Tool widgets can be locked in place by using the "Tools/Lock Layout" menu action. (#202)

- You can now push to several remotes simultaneously by selecting multiple remotes in the "Push" dialog. (#148)

- The grep tool learned to search using three different modes: basic regular expressions (default), extended regular expressions, and fixed strings.

### Packaging

- git cola now depends on the argparse Python module. This module is part of the stdlib in Python 2.7 and must be installed separately when using Python 2.6 and below.

### Fixes

- Support Unicode in the output from fetch, push, and pull.

## v1.8.5

### Usability, bells and whistles

- We now detect when the editor or history browser are misconfigured. (#197) (bz #886826)

- Display of untracked files can be disabled from the Preferences dialog or by setting the gui.displayuntracked configuration variable to false. (Git Mailing List on 2013-08-21)

### Fixes

- Unicode stash names are now supported (#198)

- The diffs produced when reverting workspace changes were made more robust.

## v1.8.4

### Usability, bells and whistles

- Brand new German translation thanks to Sven Claussner.

- The "File" menu now provides a "New Repository..." menu action.

- git dag now uses a dock-widget interface so that its widgets can be laid-out and arranged. Customizations are saved and restored the next time git dag is launched.

- git dag now has a "Zoom Best Fit" button next alongside the "Zoom In" and "Zoom Out" buttons.

- Ctrl+L now focuses the "Search" field in the git dag tool.

- Right-clicking in the "diff" viewer now updates the cursor position before performing actions, which makes it much easier to click around and selectively stage sections. Previously, the current cursor position was used which meant that it required two clicks (left-click to update the position followed by right-click to get the context menu) for the desired section to be used. This is now a single right-click operation.

- The Ctrl+D "Launch Diff Tool" action learned to automatically choose between git difftool and git mergetool. If the file is unmerged then we automatically launch git mergetool on the path, otherwise we use git difftool. We do this because git difftool is not intended to be used on unmerged paths. Automatically using git mergetool when appropriate is the most intuitive and muscle-memory-friendly thing to do.

- You can now right-click on folders in your standard file browser and choose `Open With > Git Cola` (Linux-only).

### Fixes

- Python 2.6 on Mac OS X Snow Leopard does not provide a namedtuple at sys.version_info. We now avoid using that variable for better portability.

- We now read the user's Git configuration from ~/.config/git/config if that file is available, otherwise we use the traditional ~/.gitconfig path, just like Git itself.

- Some edge cases were fixed when applying partial/selected diffs.

- The diff viewer is now properly cleared when refreshing. (#194)

## v1.8.3

### Usability, bells and whistles

- The diff viewer now has an "Options" menu which can be used to set "git diff" options. This can be used to ignore whitespace changes or to show a change with its surrounding function as context. (#150)

- git cola now remembers your commit message and will restore it when git cola is restarted. (#175)

- Ctrl+M can now be used to toggle the "Amend last commit" checkbox in the commit message editor. (#161)

- Deleting remote branches can now be done from the "Branch" menu. (#152)

- The commit message editor now has a built-in spell checker.

### Fixes

- We now avoid invoking external diffs when showing diffstats. (#163)

- The Status tool learned to reselect files when refreshing. (#165)

- git cola now remembers whether it has been maximized and will restore the maximized state when git cola is restarted. (#172)

- Performance is now vastly improved when staging hundreds or thousands of files.

- git cola was not correctly saving repo-specific configuration. (#174)

- Fix a UnicodeDecode in sphinxtogithub when building from source.

## v1.8.2

### Usability, bells and whistles

- We now automatically remove missing repositories from the "Select Repository" dialog. (#145)

- A new git cola diff sub-command was added for diffing changed files.

### Fixes

- The inotify auto-refresh feature makes it difficult to select text in the "diff" editor when files are being continually modified by another process. The auto-refresh causes it to lose the currently selected text, which is not wanted. We now avoid this problem by saving and restoring the selection when refreshing the editor. (#155)

- More strings have been marked for l10n. (#157)

- Fixed the Alt+D Diffstat shortcut. (#159)

### Fixes

- Better error handling when cloning repositories.

  We were not handling the case where a git URL has no basename, e.g. https://git.example.com/. git cola originally rejected these URLs instead of allowing users to clone them. It now allows these URLs when they point to valid git repositories.

  Additionally, git cola learned to echo the errors reported by git clone when it fails. (#156)

## v1.8.1

### Usability, bells and whistles

- git dag got a big visual upgrade.

- Ctrl+G now launches the "Grep" tool.

- Ctrl+D launches difftool and Ctrl+E launches your editor when in the diff panel.

- git-cola can now be told to use an alternative language. For example, if the native language is German and we want git-cola to use English then we can create a ~/.config/git-cola/language file with "en" as its contents: `echo en >~/.config/git-cola/language` (#140)

- A new git cola merge sub-command was added for merging branches.

- Less blocking in the main UI

### Fixes

- Autocomplete issues on KDE (#144)

- The "recently opened repositories" startup dialog did not display itself in the absence of bookmarks. (#139)

## v1.8.0

### Usability, bells and whistles

- git cola learned to honor .gitattributes when showing and interactively applying diffs. This makes it possible to store files in git using a non-UTF-8 encoding and git cola will properly accept them. This must be enabled by settings cola.fileattributes to true, as it incurs a small performance penalty. (#96)

- git cola now wraps commit messages at 72 columns automatically. This is configurable using the cola.linebreak variable to enable/disable the feature, and cola.textwidth to configure the limit. (#133)

- A new "Open Recent" sub-menu was added to the "File" menu. This makes it easy to open a recently-edited repository. (#135)

- We now show a preview for untracked files when they are clicked using the Status tool.

- A new "Open Using Default Application" action was added to the Status tool. It is activated using either Spacebar or through the context menu. This action uses xdg-open on Linux and open on Mac OS X.

- A new "Open Parent Directory" action was added to the Status tool. It is activated using either Shift+Spacebar or through the context menu.

- git dag learned to honor the log.date git configuration variable. This makes the date display follow whatever format the user has configured.

- A new git cola config sub-command was added for quickly tweaking git cola's git configuration settings.

- Some small usability tweaks -- some user confirmation prompts were defaulting to "Cancel" when they should have been defaulting to the affirmative option instead.

### Fixes

- Properly handle arbitrarily-named branches.

- We went back to launching git mergetool using an xterm. The reason is that there are a couple of places where git mergetool requires a terminal for user interaction not covered by --no-prompt.

- We now properly handle an edge case when applying short diffs at the start of a file.

## v1.7.7

### Usability, bells and whistles

- New and improved grep mode lets you instantly find and edit files.

- New git cola grep standalone mode.

- Support for passing arguments to the configured editors, e.g. gvim -p This makes it possible to select multiple files in the status window and use Ctrl + E to edit them all at once.

- Remote operations now prompt on errors only.

- The Tab key now jumps to the extended description when editing the summary.

- More shortcut key labels and misc. UX improvements.

### Fixes

- Selecting an item no longer copies its filename to the copy/paste buffer. Ctrl + C or the "Copy" context-menu action can be used instead.

- The repository monitoring feature on Windows learned to ignore changes within the ".git" directory. Thanks to Andreas Sommer. (#120)

## v1.7.6

### Usability, bells and whistles

- git dag learned to color-code branch edges. The edge colors change when a new branch is detected, which makes the history much easier to follow. A huge thanks to Uri Okrent for making it happen.

- New GUI for editing remote repositories.

- New git cola archive and git cola remote sub-commands.

- git cola browser learned an 'Untrack' command.

- The diff editor learned to staged/unstaged while amending.

- The status tool can now scroll horizontally.

- New git repositories can be created by clicking 'New' on the git cola --prompt startup screen.

## v1.7.5

### Usability, bells and whistles

- Auto-completion was added to more tools.

- git dag is easier to use on smaller displays -- the author field elides its text which allows for a more compact display.

- Selected commits in git dag were made more prominent and easier to see.

- 'Create Branch' learned to fetch remote branches and uses a background thread to do so.

- User-configured GUI tools are listed alphabetically in the 'Actions' menu.

- The 'Pull' dialog remembers the value of the 'Rebase' checkbox between invocations.

## v1.7.4.1

### Fixes

- Detect Homebrew so that OS X users do not need to set PYTHONPATH.

- git dag can export patches again.

## v1.7.4

### Usability, bells and whistles

- The 'Classic' tool was renamed to 'Browser' and learned to limit history to the current branch.

- git dag learned about gravatar and uses it to show images for commit authors.

- git dag learned to use OpenGL for rendering resulting in much faster rendering.

- More dialogs learned vim-style keyboard shortcuts.

- The commit message editor learned better arrow key navigation.

## v1.7.3

### Usability, bells and whistles

- git cola learned a few new sub commands:

    git cola dag
    git cola branch
    git cola search

- Return in the summary field jumps to the extended description.

- Ctrl+Return is now a shortcut for 'Commit'.

- Better French translation for 'Sign-off'.

- The 'Search' widget now has a much simpler and streamlined user interface.

- vim-style h,j,k,l navigation shortcuts were added to the DAG widget.

- git dag no longer prompts for files when diffing commits if the text field contains paths.

- General user interface and performance improvements.

### Fixes

- The diff viewer no longer changes font size when holding Control while scrolling with the mouse wheel.

- Files with a type change (e.g. symlinks that become files, etc.) are now correctly identified as being modified.

### Packaging

- The cola.controllers and cola.views packages were removed.

## v1.7.2

### Usability, bells and whistles

- git cola can now launch sub commands, e.g.:

    git cola classic
    git cola stash
    git cola fetch
    git cola push
    git cola pull
    git cola tag

- git dag is more responsive when gathering auto-completions.

- Keyboard shortcuts are displayed when the '?' key is pressed.

- Various keyboard shortcuts were added for improved usability.

- The status widget now lists unmerged files before modified files.

- vim-style h,j,k,l navigation shortcuts were added to the status widget.

- A 'Recently Modified Files...' tool was added.

- Tools can now be hidden with Alt + # (where # is a keyboard number) and focused with Alt + Shift + #.

- The syntax highlighting colors for diffs was made less intrusive.

- The commit message editor was redesigned to have a more compact and keyboard-convenient user interface.

- Keyboard shortcuts for adding a Signed-off-by (Ctrl + i) and creating a commit (Ctrl + m) were added.

- The status widget was adjusted to use less screen real-estate.

### Fixes

- Avoid updating the index when responding to inotify events. This avoids interfering with operations such as git rebase --interactive. (#99)

### Packaging

- Create git-dag.pyw in the win32 installer.

- win32 shortcuts now contain explicit calls to pythonw.exe instead of calling the .pyw file directly.

### Deprecated Features

- The 'Apply Changes from Branch...' feature was removed. git dag's 'Grab File...' feature used alongside the index/worktree editor is a simpler alternative.

## v1.7.1.1

### Fixes

- Further enhanced the staging/unstaging behavior in the status widget. (#97)

- Unmerged files are no longer listed as modified.

### Packaging

The cola-$version tarballs on github were originally setup to have the same contents as the old tarballs hosted on tuxfamily. The make dist target was changed to write files to a git-cola-$version subdirectory and tarball.

This makes the filenames consistent for the source tarball, the darwin .app tarball, and the win32 .exe installer.

## v1.7.1

### Usability, bells and whistles

- Refined the staging/unstaging behavior for code reviews. (#97)

- Added more styling and icons to menus and buttons.

- Adjusted some terminology to more closely match the git CLI.

### Fixes

- Boolean git config settings with no value are now supported (these are not created by git these days but exist in legacy repositories).

- Unicode branches and tags are supported in the "branch diff" tool.

- Guard against low-memory conditions and more interrupted system calls.

### Packaging

- Added desktop launchers for git-cola.desktop and git-dag.desktop. This replaces the old cola.desktop, so some adjustments to RPM .spec and debian/ files will be needed.

- Fixed the darwin app-tarball Makefile target to create relative paths.

### Cleanup

- The --style option was removed. git cola follows the system theme so there's no need for this option these days.

## v1.7.0

### Usability, bells and whistles

- Export a patch series from git dag into a patches/ directory.

- git dag learned to diff commits, slice history along paths, etc.

- Added instant-preview to the git stash widget.

- A simpler preferences editor is used to edit git config values. (#90) (#89)

- Previous commit messages can be re-loaded from the message editor. (#33)

### Fixes

- Display commits with no file changes. (#82)

- Improved the diff editor's copy/paste behavior (#90)

### Packaging

- Bumped version number to ceil(minimum git version). git cola now requires git >= 1.6.3.

- Simplified git-cola's versioning when building from tarballs outside of git. We no longer check for a 'version' file at the root of the repository. We instead keep a default version in cola/version.py and use it when git cola's .git repository is not available.

## v1.4.3.5

### Usability, bells and whistles

- inotify is much snappier and available on Windows thanks to Karl Bielefeldt.

- New right-click command to add untracked files to .gitignore thanks to Audrius Karabanovas.

- Stash, fetch, push, and pull usability improvements

- General usability improvements

- stderr is logged when applying partial diffs.

### Fixes

- Files can be unstaged when amending. (#82)

- Show the configured remote.$remote.pushurl in the GUI (#83)

- Removed usage of the "user" module. (#86)

- Avoids an extra git update-index call during startup.

## v1.4.3.4

### Usability, bells and whistles

- We now provide better feedback when git push fails. (#69)

- The Fetch, Push, and Pull dialogs now give better feedback when interacting with remotes. The dialogs are modal and a progress dialog is used.

### Fixes

- More Unicode fixes, again. It is now possible to have Unicode branch names, repository paths, home directories, etc. This continued the work initiated by Redhat's bugzilla #694806.

  https://bugzilla.redhat.com/show_bug.cgi?id=694806

## v1.4.3.3

### Usability, bells and whistles

- The git cola desktop launchers now prompt for a repo by default. This is done by using the new --prompt flag which tells git cola to ignore any git repositories in the current directory and prompt for one instead.

### Fixes

- More Unicode fixes for repositories and home directories with embedded Unicode characters. Thanks to Christian Jann for patience and helpful bug reports.

- Fix the 'Clone' button in the startup dialog.

## v1.4.3.2

### Usability, bells and whistles

- Faster startup time! git cola now offloads initialization to a background thread so that the GUI appears almost instantly.

- Specialized diff options for p4merge, vimdiff, araxis, emerge, and ecmerge in difftool (backported from git.git).

### Fixes

- Fix launching commands in the background on Windows (e.g. when launching git difftool).

- Fix Unicode errors when home or repository directories contain Unicode characters. (#74) (bz #694806)

## v1.4.3.1

### Usability, bells and whistles

- The cola classic tool can be now configured to be dock-able. (#56)

- The cola classic tool now uses visual sigils to indicate a file's status. The idea and icons were provided by Uri Okrent.

- Include the 'Rescan' button in the 'Actions' widget regardless of whether inotify is installed.

### Packaging

- Fix installation of translations per Fedora This incorporates Fedora's fix for the translations path which originally appeared in cola-1.4.3-translations.patch.

- Mac OS X git-cola developers can now generate git-cola.app application bundles using 'make app-bundle'.

### Fixes

- Fixed an error when trying to use "Get Commit Message Template" with an undefined "commit.template" git config variable. (bz #67521) (#72)

- Properly raise the main window on Mac OS X.

- Properly handle staging a huge numbers of files at once.

- Speed up 'git config' usage by fixing cola's caching proxy.

- Guard against damaged ~/.cola files.

## v1.4.3

### Usability, bells and whistles

- git dag now has a separate display area for displaying commit metadata. This area will soon grow additional functionality such as cherry-picking, branching, etc.

### Fixes

- Fixed tests from a previous refactoring.

- Guard against 'diff.external' configuration by always calling 'git diff' with the '--no-ext-diff' option. (#67)

- Respect 'gui.diffcontext' so that cola's diff display shows the correct number of context lines.

- Raise the GUI so that it is in the foreground on OS X.

### Packaging

- We now allow distutils to rewrite cola's shebang line. This allows us to run on systems where "which python" is Python3k. This is exposed by setting the PYTHON Makefile variable to the location of python2.x.

- git-cola.app is now a tiny download because it no longer contains Qt and PyQt. These libraries are provided as a separate download.

## v1.4.2.5

### Usability, bells and whistles

- Clicking on paths in the status widget copies them into the copy/paste buffer for easy middle-clicking into terminals.

- Ctrl+C in diff viewer copies the selected diff to the clipboard.

### Fixes

- Fixed the disappearing actions buttons on PyQt 4.7.4 as reported by Arch and Ubuntu 10.10. (#62)

- Fixed mouse interaction with the status widget where some items could not be de-selected.

### Packaging

- Removed hard-coded reference to lib/ when calculating Python's site-packages directory.

## v1.4.2.4

### Usability, bells and whistles

- Removed "single-click to (un)stage" in the status view. This is a usability improvement since we no longer perform different actions depending on where a row is clicked.

- Added ability to create unsigned, annotated tags.

### Fixes

- Updated documentation to use cola.git instead of cola.gitcmd.

## v1.4.2.3

### Usability, bells and whistles

- Allow un/staging by right-clicking top-level items (#57)

- Running 'commit' with no staged changes prompts to allow staging all files. (#55)

- Fetch, Push, and Pull are now available via the menus (#58)

### Fixes

- Simplified the actions widget to work around a regression in PyQt4 4.7.4. (#62)

## v1.4.2.2

### Usability, bells and whistles

- git dag interaction was made faster.

### Fixes

- Added '...' indicators to the buttons for 'Fetch...', 'Push...', 'Pull...', and 'Stash...'. (#51)

- Fixed a hang-on-exit bug in the cola-provided 'ssh-askpass' implementation.

## v1.4.2.1

### Usability, bells and whistles

- Staging and unstaging is faster. (#48)

- git dag reads history in a background thread.

### Portability

- Added cola.compat.hashlib for Python 2.4 compatibility

- Improved PyQt 4.1.x compatibility.

### Fixes

- Configured menu actions use `sh -c` for Windows portability.

## v1.4.2

### Usability, bells and whistles

- Added support for the configurable `guitool.<tool>.*` actions as described in the `git config` documentation. (git-config(1)) (#44)

  This makes it possible to add new actions to git cola by simply editing `~/.gitconfig`. This implements the same guitool support as git gui.

- Introduced a stat cache to speed up git config and repository status checks.

- Added Alt-key shortcuts to the main git cola interface.

- The Actions dock widget switches between a horizontal and vertical layout when resized.

- We now use `git diff --submodule` for submodules (used when git >= 1.6.6).

- The context menu for modified submodules includes an option to launch git cola. (#17)

- Prefer `$VISUAL` over `$EDITOR` when both are defined. These are used to set a default editor in lieu of core.editor configuration.

- Force the editor to be `gvim` when we see `vim`. This prevents us from launching an editor in the (typically unattached) parent terminal and creating zombie editors that cannot be easily killed.

- Selections are remembered and restored across updates. This makes the partial-staging workflow easier since the diff view will show the updated diff after staging.

- Show the path to the current repository in a tooltip over the commit message editor. (#45)

- Log internal `git` commands when `GIT_COLA_TRACE` is defined. (#39)

### Fixes

- Improved backwards compatibility for Python 2.4.

- Review mode can now review the current branch; it no longer requires you to checkout the branch into which the reviewed branch will be merged.

- Guard against color.ui = always configuration when using git log by passing `--no-color`.

- `yes` and `no` are now supported as valid booleans by the git config parser.

- Better defaults are used for fetch, push, and pull.. (#43)

### Packaging

- Removed colon (:) from the application name on Windows (#41)

- Fixed bugs with the Windows installer (#40)

- Added a more standard i18n infrastructure. The install tree now has the common `share/locale/$lang/LC_MESSAGES/git-cola.mo` layout in use by several projects.

- Started trying to accommodate Mac OS X 10.6 (Snow Leopard) in the `darwin/` build scripts but our tester is yet to report success building a .app bundle.

- Replaced use of `perl` in Sphinx/documentation Makefile with more-portable `sed` constructs. Thanks to Stefan Naewe for discovering the portability issues and providing msysgit-friendly patches.

## v1.4.1.2

### Usability, bells and whistles

- It is now possible to checkout from the index as well as from HEAD. This corresponds to the Removed Unstaged Changes action in the Repository Status tool.

- The remote dialogs (fetch, push, pull) are now slightly larger by default.

- Bookmarks can be selected when git cola is run outside of a git repository.

- Added more user documentation. We now include many links to external git resources.

- Added git dag to the available tools. git dag is a node-based DAG history browser. It doesn't do much yet, but it's been merged so that we can start building and improving upon it.

### Fixes

- Fixed a missing `import` when showing right-click actions for unmerged files in the Repository Status tool.

- `git update-index --refresh` is no longer run every time `git cola version` is run.

- Don't try to watch non-existent directories when using inotify.

- Use `git rev-parse --symbolic-full-name` plumbing to find the name of the current branch.

### Packaging

- The `Makefile` will now conditionally include a `config.mak` file located at the root of the project. This allows for user customizations such as changes to the prefix variable to be stored in a file so that custom settings do not need to be specified every time on the command-line.

- The build scripts no longer require a `.git` directory to generate the `builtin_version.py` module. The release tarballs now include a `version` file at the root of the project which is used in lieu of having the git repository available. This allows for `make clean && make` to function outside of a git repository.

- Added maintainer's `make dist` target to the `Makefile`.

- The built-in simplejson and jsonpickle libraries can be excluded from `make install` by specifying the `standalone=true` make variable. For example, `make standalone=true install`. This corresponds to the `--standalone` option to `setup.py`.

## v1.4.1.1

### Usability, bells and whistles

- We now use patience diff by default when it is available via git diff --patience.

- Allow closing the cola classic tool with Ctrl+W.

### Fixes

- Fixed an unbound variable error in the push dialog.

### Packaging

- Don't include simplejson in MANIFEST.in.

- Update desktop entry to read Cola Git GUI.

## v1.4.1

This feature release adds two new features directly from git cola's github issues backlog. On the developer front, further work was done towards modularizing the code base.

### Usability, bells and whistles

- Dragging and dropping patches invokes git am (#3)

- A dialog to allow opening or cloning a repository is presented when git cola is launched outside of a git repository. (#22)

- Warn when push is used to create a new branch (#35)

- Optimized startup time by removing several calls to git.

### Portability

- git cola is once again compatible with PyQt 4.3.x.

### Developer

- cola.gitcmds was added to factor out git command-line utilities

- cola.gitcfg was added for interacting with git config

- cola.models.browser was added to factor out repo browser data

- Added more tests

## v1.4.0.5

### Fixes

- Fix launching external applications on Windows

- Ensure that the amend checkbox is unchecked when switching modes

- Update the status tree when amending commits

## v1.4.0.4

### Packaging

- Fix Lintian warnings

## v1.4.0.3

### Fixes

- Fix X11 warnings on application startup

## v1.4.0.2

### Fixes

- Added missing 'Exit Diff Mode' button for 'Diff Expression' mode (#31)

- Fix a bug when initializing fonts on Windows (#32)

## v1.4.0.1

### Fixes

- Keep entries in sorted order in the cola classic tool

- Fix staging untracked files (#27)

- Fix the show command in the Stash dialog (#29)

- Fix a typo when loading merge commit messages (#30)

## v1.4.0

This release focuses on a redesign of the git-cola user interface, a tags interface, and better integration of the cola classic tool. A flexible interface based on configurable docks is used to manage the various cola widgets.

### Usability, bells and whistles

- New GUI is flexible and user-configurable

- Individual widgets can be detached and rearranged arbitrarily

- Add an interface for creating tags

- Provide a fallback SSH_ASKPASS implementation to prompt for SSH passwords on fetch/push/pull

- The commit message editor displays the current row/column and warns when lines get too long

- The cola classic tool displays upstream changes

- git cola --classic launches cola classic in standalone mode

- Provide more information in log messages

### Fixes

- Inherit the window manager's font settings

- Miscellaneous PyQt4 bug fixes and workarounds

### Developer

- Removed all usage of Qt Designer .ui files

- Simpler model/view architecture

- Selection is now shared across tools

- Centralized notifications are used to keep views in sync

- The cola.git command class was made thread-safe

- Less coupling between model and view actions

- The status view was rewritten to use the MVC architecture

- Added more documentation and tests

## v1.3.9

### Usability, bells and whistles

- Added a cola classic tool for browsing the entire repository

- Handle diff expressions with spaces

- Handle renamed files

### Portability

- Handle carat ^ characters in diff expressions on Windows

- Worked around a PyQt 4.5/4.6 QThreadPool bug

### Documentation

- Added a keyboard shortcuts reference page

- Added developer API documentation

### Fixes

- Fix the diff expression used when reviewing branches

- Fix a bug when pushing branches

- Fix X11 warnings at startup

- Fix more interrupted system calls on Mac OS X

## v1.3.8

### Usability, bells and whistles

- Fresh and tasty SVG logos

- Added Branch Review mode for reviewing topic branches

- Added diff modes for diffing between tags, branches, or arbitrary git diff expressions

- The push dialog selects the current branch by default. This is in preparation for git 1.7.0 where git push will refuse to push when run without specifying the remote name and branch. See the git release notes for more information

- Support open and clone commands on Windows

- Allow saving cola UI layouts

- Re-enabled double-click-to-stage for unmerged entries. Disabling it for unmerged items was inconsistent, though safer.

- Show diffs when navigating the status tree with the keyboard

### Packaging

- Worked around pyuic4 bugs in the setup.py build script

- Added Mac OS X application bundles to the download page

## v1.3.7

### Subsystems

- git difftool became an official git command in git 1.6.3.

- git difftool learned --no-prompt / -y and a corresponding difftool.prompt configuration variable

### Usability, bells and whistles

- Warn when non-fast-forward is used with fetch, push or pull

- Allow Ctrl+C to exit cola when run from the command line

### Fixes

- Support Unicode font names

- Handle interrupted system calls

### Developer

- More of the code base was updated to follow the PEP-8 coding style

- Added more tests

### Packaging

- All resources are now installed into $prefix/share/git-cola. Closed Debian bug #519972

  https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=519972

## v1.3.6

### Subsystems

- Added support for Kompare in git difftool

- Added a separate configuration namespace for git difftool

- Added the diff.tool configuration variable to define the default diff tool

### Usability, bells and whistles

- The stash dialog allows passing the --keep-index option to git stash

- Amending a published commit warns at commit time

- Simplified the file-across-revisions comparison dialog

- origin is selected by default in fetch/push/pull

- Removed the search field from the log widget

- The log window moved into a drawer widget at the bottom of the UI

- Log window display can be configured with cola.showoutput = {never, always, errors}. errors is the default.

- NOTE -- cola.showoutput was removed with the GUI rewrite in 1.4.0.

### Developer

- Improved nose unittest usage

### Packaging

- Added a Windows/msysGit installer

- Included private versions of simplejson and jsonpickle for ease of installation and development